import { Select as AntSelect } from 'antd';
import { SelectProps } from 'antd/es/select';
import React from 'react';
import { PromiseType, TypeExtends } from '../util';
type TypeProps<T> = TypeExtends<T, {
    multiple?: boolean;
    /**
     * @description       自定义tooltip
     */
    tooltip?: string | ((value: any) => PromiseType<React.ReactNode>);
    allowNull?: boolean;
    fitHeight?: boolean;
    data?: Array<any>;
    valueField?: string;
    labelField?: string;
    onChange?: (value: any) => void;
    request?: (params: any) => Promise<any>;
}>;
type OptionType = typeof AntSelect.Option;
export declare class Select extends React.Component<TypeProps<SelectProps> & {
    editable?: boolean;
    isTree?: boolean;
}> {
    static Option: OptionType;
    outRef: React.RefObject<any>;
    getApi(): any;
    setReadOnly(...args: any[]): void;
    on(...args: any[]): void;
    render(): import("react/jsx-runtime").JSX.Element;
}
export declare const MultipleSelect: React.ForwardRefExoticComponent<Omit<TypeProps<SelectProps<any, import("antd/es/select").DefaultOptionType>>, "multiple"> & React.RefAttributes<any>>;
export {};
