function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { CheckCircleFilled, CloseCircleFilled, FileExcelFilled, FileImageFilled, FilePdfFilled, FileTextFilled, FileWordFilled, FileZipFilled } from '@ant-design/icons';
import { Progress } from 'antd';
import { useMemo } from 'react';
import { getFileSize, getFileType } from "../util";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
var fileIconMap = {
  doc: FileWordFilled,
  docx: FileWordFilled,
  xls: FileExcelFilled,
  xlsx: FileExcelFilled,
  pdf: FilePdfFilled,
  zip: FileZipFilled,
  png: FileImageFilled,
  jpg: FileImageFilled,
  jpeg: FileImageFilled,
  gif: FileImageFilled
};
var colorMap = {
  xls: '#53D39C',
  xlsx: '#53D39C',
  pdf: '#FF7878',
  zip: '#FF7878'
};
export function FileView(props) {
  var _props$style = props.style,
    style = _props$style === void 0 ? {} : _props$style,
    handlePreview = props.handlePreview,
    _props$isPreview = props.isPreview,
    isPreview = _props$isPreview === void 0 ? true : _props$isPreview,
    data = props.data,
    _props$iconPosition = props.iconPosition,
    iconPosition = _props$iconPosition === void 0 ? 'left' : _props$iconPosition;
  var _useMemo = useMemo(function () {
      return {
        fileType: getFileType(data.fileName),
        fileSizeStr: getFileSize(data.fileSize)
      };
    }, [data]),
    fileType = _useMemo.fileType,
    fileSizeStr = _useMemo.fileSizeStr;
  var Icon = fileIconMap[fileType] ? fileIconMap[fileType] : FileTextFilled;
  var color = data.status === 'fail' ? '#ff3333' : colorMap[fileType] || '#53B7F4';
  var nodes = [/*#__PURE__*/_jsx("span", {
    style: {
      marginRight: 5
    },
    children: /*#__PURE__*/_jsx(Icon, {
      style: _objectSpread({
        fontSize: 20,
        color: color
      }, style)
    })
  }, "file-icon"), /*#__PURE__*/_jsx("span", {
    title: data.fileName,
    className: "attachment-overflow ".concat(isPreview ? 'attachment-preview-file' : ''),
    onClick: isPreview ? handlePreview : undefined,
    children: data.fileName
  }, "file-fileName"), /*#__PURE__*/_jsxs("span", {
    className: "attachment-file-size",
    style: {
      color: 'var(--primary-color)'
    },
    children: ["\uFF08", fileSizeStr, "\uFF09"]
  }, "file-size")];
  if (data.status === 'done') {
    var iconNode = /*#__PURE__*/_jsx(CheckCircleFilled, {
      className: "file-status-icon done"
    }, "file-done");
    iconPosition === 'left' ? nodes.unshift(iconNode) : nodes.push(iconNode);
  }
  if (data.status === 'fail') {
    var _iconNode = /*#__PURE__*/_jsx(CloseCircleFilled, {
      className: "file-status-icon failed"
    }, "file-failed");
    iconPosition === 'left' ? nodes.unshift(_iconNode) : nodes.push(_iconNode);
  }
  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [nodes, data.status === 'uploading' && data.percent !== undefined && /*#__PURE__*/_jsx(Progress, {
      percent: data.percent,
      size: "small",
      status: "active",
      className: "attachment-progress",
      showInfo: false
    })]
  });
}