function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { Input, Modal } from 'antd';
import { useEffect, useState } from 'react';
import { message } from "../../../functionalComponent";
import { tableAttachSaveRemark } from "../service";
import { jsx as _jsx } from "react/jsx-runtime";
export var RemarkModal = function RemarkModal(props) {
  var data = props.data,
    visible = props.visible,
    disabled = props.disabled,
    onCancel = props.onCancel,
    onSaved = props.onSaved;
  var _ref = data || {},
    asrFid = _ref.asrFid,
    asrRemark = _ref.asrRemark;
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    remark = _useState2[0],
    setRemark = _useState2[1];
  useEffect(function () {
    visible && setRemark(asrRemark);
  }, [asrRemark, visible]);
  return /*#__PURE__*/_jsx(Modal, {
    open: visible,
    title: "\u4FEE\u6539\u5907\u6CE8",
    onOk: function onOk() {
      if (disabled) {
        onCancel();
        return;
      }
      tableAttachSaveRemark({
        fileId: asrFid,
        remark: remark
      }).then(function (res) {
        if ((res === null || res === void 0 ? void 0 : res.code) === 0) {
          message.success('备注保存成功');
          onSaved();
          onCancel();
        }
      });
    },
    onCancel: onCancel,
    okText: "\u4FDD\u5B58",
    children: /*#__PURE__*/_jsx(Input.TextArea, {
      disabled: disabled,
      rows: 5,
      value: remark,
      onChange: function onChange(e) {
        return setRemark(e.target.value);
      },
      maxLength: 500
    })
  });
};