export type uploadFileParams = {
    chunkNumber: number;
    chunkSize: number;
    currentChunkSize: number;
    totalChunks: number;
    totalSize: number;
    fileName: string;
    md5: string;
    file: File | Blob;
    busiType: string;
    cursorId?: string;
    ctlgId?: string;
    unitNo?: string;
    bizCode?: string;
};
export type getTempAttachmentParams = {
    cursorId: string;
};
export type getAttachListParams = {
    busiIds: string;
    fileName?: string;
    fileType?: string;
    tag?: string;
    unitNo?: string;
    orgNo?: string;
    projCode?: string;
    bizCode?: string;
};
export type attachDataRes = {
    fileId: string;
    fileName: string;
    fileFormat: string;
    createTime: Date;
    fileSize: string;
    originFileSize: number;
    typeId: string;
    typeName: string;
    busiId: string;
    createId: string;
    uploadName: string;
    remark: string;
    status: number;
    tag?: string;
    label?: string[];
};
export type attachListDataRes = {
    cursorId: string;
    data: object[];
    previewFileType?: string[];
    fileBlackList?: string;
    fileWhiteList?: string;
    specialChars?: string;
};
export type downloadFileParams = {
    fileId: string;
    fileTitle?: string;
};
export type createZipParams = {
    busiIds?: string;
    tag?: string;
    orgNo?: string;
    projCode?: string;
    unitNo?: string;
};
export type getZipDownloadInfoParams = {
    id: string;
};
export type tableAttachSaveRemarkParams = {
    fileId: string;
    remark: string;
};
export type attachLabelSaveParams = {
    fileId: string;
    label: string[];
};
export type getDownLoadHistoryParams = {
    fileId: string;
};
export type downLoadHistoryRes = {
    userName: string;
    createId: string;
    createTime: Date;
    title: string;
    fileName: string;
    fileFormat: string;
    size: string;
    fileSize: number;
    storeName: string;
    typeName: string;
};
export type attachDeleteParams = {
    fileIds: string;
    cursorId: string;
};
export type attachSaveParams = {
    cursorId: string;
    busiId?: string;
    unitNo?: string;
    orgNo?: string;
    projCode?: string;
    tag?: string;
};
export type getPreviewUrlParams = {
    fileId: string;
};
