/**
 * 客户帮助
 */
import React from 'react';
import { BaseHelpProps } from '../../functionalComponent';
import { IObject } from '../../functionalComponent/table/util';
export interface ICustomerHelp extends BaseHelpProps {
    displayField?: string;
    /**
     * @description       自定义弹出帮助的title
     * @default           客户帮助
     */
    title?: string;
    /**
     * @description       是否开启多选模式
     * @default           false
     */
    multiple?: boolean;
    codeList: string[];
    /**
     * @description       底部扩展组件
     */
    footer?: React.ReactNode;
    /**
     * @description       自定义弹窗客户数据请求
     */
    customerBusinessRequest?: (params: IObject) => Promise<{
        list: any[];
        total: number | string;
    }>;
    /**
     * @description       自定义弹窗客户数据请求参数
     */
    customerBusinessParams?: IObject;
    /**
     * @description       弹窗表格列配置
     */
    columns?: IObject[];
}
/**
 * 客户帮助
 */
export declare const CustomerHelp: React.ForwardRefExoticComponent<Omit<ICustomerHelp & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
