import React from 'react';
import { BaseHelpProps } from '../../functionalComponent';
import { IObject } from '../../util';
interface IParam {
    pageNum?: number;
    pageSize?: number;
    pluginCode: string;
    indicatorsData: string;
    indicatorsCode: string;
    orgCode: string;
    [prop: string]: any;
    clientSqlFilter?: string | IObject | (({ ds, row, value, dataIndex, helpId }: {
        ds: Array<any>;
        row: any;
        value: any;
        dataIndex: string;
        helpId: string;
    }) => string | IObject);
}
export interface BaseDedicatedHelp {
    /**
     * @description        同labelField,优先级略低
     */
    displayField?: string;
    /**
     * @description       自定义弹出帮助的title
     */
    title?: string;
    /**
     * @description       是否开启多选模式
     * @default           false
     */
    multiple?: boolean;
    /**
     * @description       底部扩展组件
     */
    footer?: React.ReactNode;
    /**
     * @description       表格列配置
     */
    columns?: IObject[];
    /**
     * @description       接口列表参数
     * {
          pluginCode: string; // 插件编码
          indicatorsData: string; // 指标值
          indicatorsCode: string; // 参数编码
          orgCode: string; // 组织编码;
        };
     */
    params?: IParam;
    /**
     * @description       自定义请求
     */
    customRequest?: (params: IParam | undefined) => Promise<{
        list: any[];
        total: number | string;
    }>;
    /**
     * @description   查询参数
     */
    clientSqlFilter?: string | IObject | (({ ds, row, value, dataIndex }: {
        ds: Array<any>;
        row: any;
        value: any;
        dataIndex: string;
        helpId: string;
    }) => string | IObject);
}
export type IDedicatedHelp = BaseDedicatedHelp & BaseHelpProps;
/**
 * 指标帮助
 */
export declare const DedicatedHelp: React.ForwardRefExoticComponent<Omit<BaseDedicatedHelp & BaseHelpProps & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export default DedicatedHelp;
