import React from 'react';
import { type BaseHelpProps } from '../../functionalComponent';
import { type IObject } from '../../util';
import { type OrgTreeType } from '../org-tree';
interface EnterprisePositionsParamType {
    containLowOrg?: boolean;
    dataAccessAuth?: boolean;
    enableManagerContrl?: boolean;
    pageNum: number;
    pageSize: number;
    orgNo?: string;
    keyWord?: string;
}
interface BaseEnterprisePositionsHelp extends BaseHelpProps {
    displayField?: string;
    /**
     * @description       自定义弹出帮助的title
     */
    title?: string;
    /**
     * @description       是否开启多选模式
     * @default           false
     */
    multiple?: boolean;
    /**
     * @description       底部扩展组件
     */
    footer?: React.ReactNode;
    /**
     * @description       表格列配置
     */
    columns?: IObject[];
    /**
     * @description       项目列表参数
     */
    enterprisePositionsParams?: EnterprisePositionsParamType;
    /**
     * @description       自定义项目请求
     */
    enterprisePositionsRequest?: (params: EnterprisePositionsParamType) => Promise<{
        list: any[];
        total: number | string;
    }>;
    /**
     * @description       组织树的属性
     */
    treeProps?: OrgTreeType;
    params?: OrgTreeType['params'];
    treeRequest?: OrgTreeType['treeRequest'];
    beforeRequest?: OrgTreeType['beforeRequest'];
}
export type IEnterprisePositionsHelp = BaseEnterprisePositionsHelp;
/**
 * 项目帮助
 */
export declare const EnterprisePositionsHelp: React.ForwardRefExoticComponent<Omit<BaseEnterprisePositionsHelp & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export {};
