import React from 'react';
import { type BaseHelpProps } from '../../functionalComponent';
import { type OrgTreeType } from '../org-tree';
interface BaseOrgHelp extends BaseHelpProps {
    displayField?: string;
    /**
     * @description       自定义弹出帮助的title
     * @default           组织帮助
     */
    title?: string;
    /**
     * @description       仅支持选择部门
     * @default           false
     */
    isOnlyDept?: boolean;
    /**
     * @description       是否开启多选模式
     * @default           true
     */
    multiple?: boolean;
    /**
     * @description       底部扩展组件
     */
    footer?: React.ReactNode;
}
export type IOrgHelp = BaseOrgHelp & OrgTreeType;
/**
 * 组织或部门
 */
declare function BaseOrgHelp(props: IOrgHelp): import("react/jsx-runtime").JSX.Element;
/**
 * 组织帮助
 */
export declare const OrgHelp: React.ForwardRefExoticComponent<Omit<BaseOrgHelp & Omit<import("../../functionalComponent").IAsyncTreeProps, "request"> & {
    defaultSelectedFirstNode?: boolean | undefined;
    params?: import("../org-tree").OrgTreeParamType | undefined;
    beforeRequest?: ((...args: any[]) => Promise<boolean | void>) | undefined;
    treeRequest?: ((params: import("../org-tree").OrgTreeParamType) => Promise<any[]>) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
/**
 * 部门帮助
 */
export declare const DeptHelp: React.ForwardRefExoticComponent<Omit<BaseOrgHelp & Omit<import("../../functionalComponent").IAsyncTreeProps, "request"> & {
    defaultSelectedFirstNode?: boolean | undefined;
    params?: import("../org-tree").OrgTreeParamType | undefined;
    beforeRequest?: ((...args: any[]) => Promise<boolean | void>) | undefined;
    treeRequest?: ((params: import("../org-tree").OrgTreeParamType) => Promise<any[]>) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export {};
