function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { Checkbox, Dropdown } from 'antd';
import { memo, useMemo, useState } from 'react';
import { Layout, useRefCallback } from "../../../util";
import { OrgTree as Tree } from "../../org-tree";

/**
 * 组织树
 * @param props
 * @constructor
 */
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
function OrgTree(props) {
  var params = useMemo(function () {
    return _objectSpread({
      containDept: false,
      dataAccessAuth: true
    }, props.params);
  }, [props.params]);
  return /*#__PURE__*/_jsx(Tree /* defaultSelectedFirstNode */, _objectSpread(_objectSpread({}, props), {}, {
    params: params
  }));
}

/**
 * tree
 * @param props
 * @returns
 */
function ProjectEngineeringTree(props) {
  var treeProps = props.treeProps,
    getTable = props.getTable;
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    treeSelectedKeys = _useState2[0],
    setTreeSelectedKeys = _useState2[1];

  // 点击包含下级
  var onChangeIfNeedSub = useRefCallback(function (value) {
    getTable().setExtraParam({
      containLowOrgUser: value
    });
  });

  // 受控select
  var onControlledSelect = useRefCallback(function (keys, _ref) {
    var selectedNodes = _ref.selectedNodes;
    var treeNodes = selectedNodes.filter(function (xt) {
      return !treeSelectedKeys.includes(xt.key);
    }) || [];
    var treeKeys = keys.filter(function (xt) {
      return !treeSelectedKeys.includes(xt);
    }) || [];
    getTable().setExtraParam({
      treeNodes: treeNodes
    });
    setTreeSelectedKeys(treeKeys);
  });

  // <包含下级> 功能
  var handleFilter = function handleFilter(DefaultCom) {
    return /*#__PURE__*/_jsxs(_Fragment, {
      children: [DefaultCom, /*#__PURE__*/_jsx(Checkbox, {
        style: {
          marginBottom: 5
        },
        onChange: function onChange(e) {
          onChangeIfNeedSub(e.target.checked);
        },
        children: "\u5305\u542B\u4E0B\u7EA7"
      })]
    });
  };
  return /*#__PURE__*/_jsx(Layout.Flex, {
    direction: "row",
    style: {
      height: '100%',
      border: '1px solid var(--border-color-split, #f0f0f0)'
    },
    children: /*#__PURE__*/_jsx(OrgTree, _objectSpread(_objectSpread({}, treeProps), {}, {
      showFilter: handleFilter,
      selectedKeys: treeSelectedKeys,
      onSelect: onControlledSelect,
      titleRender: function titleRender(_ref2) {
        var title = _ref2.title,
          key = _ref2.key;
        return /*#__PURE__*/_jsx(Dropdown, {
          disabled: !treeSelectedKeys.includes(key),
          trigger: ['contextMenu'],
          menu: {
            items: [{
              key: 'cancle',
              label: '取消选中'
            }]
          },
          placement: "top",
          children: /*#__PURE__*/_jsx("span", {
            children: title
          })
        });
      }
    }))
  });
}
export default /*#__PURE__*/memo(ProjectEngineeringTree);