import React from 'react';
import { type BaseHelpProps } from '../../functionalComponent';
import { type IObject } from '../../util';
import { type OrgTreeType } from '../org-tree';
interface ProjectParamType {
    containLowOrg?: boolean;
    dataAccessAuth?: boolean;
    enableManagerContrl?: boolean;
    pageNum: number;
    pageSize: number;
    projCode?: string;
    keyWord?: string;
}
interface BaseProjectPositionsHelp extends BaseHelpProps {
    displayField?: string;
    /**
     * @description       自定义弹出帮助的title
     */
    title?: string;
    /**
     * @description       是否开启多选模式
     * @default           false
     */
    multiple?: boolean;
    /**
     * @description       底部扩展组件
     */
    footer?: React.ReactNode;
    /**
     * @description       表格列配置
     */
    columns?: IObject[];
    /**
     * @description       岗位列表参数
     */
    projectParams?: ProjectParamType;
    /**
     * @description       自定义岗位请求
     */
    projectRequest?: (params: ProjectParamType) => Promise<{
        list: any[];
        total: number | string;
    }>;
    /**
     * @description       组织树的属性
     */
    treeProps?: OrgTreeType;
    params?: OrgTreeType['params'];
    treeRequest?: OrgTreeType['treeRequest'];
    beforeRequest?: OrgTreeType['beforeRequest'];
}
export type IProjectPositionsHelp = BaseProjectPositionsHelp;
/**
 * 岗位帮助
 */
export declare const ProjectPositionsHelp: React.ForwardRefExoticComponent<Omit<BaseProjectPositionsHelp & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export {};
