/**
 * 标准岗位帮助
 */
import React from 'react';
import { BaseHelpProps } from '../../functionalComponent';
import { IObject } from '../../functionalComponent/table/util';
export interface IStandardPositionsHelp extends BaseHelpProps {
    displayField?: string;
    /**
     * @description       自定义弹出帮助的title
     * @default           标准岗位帮助
     */
    title?: string;
    /**
     * @description       是否开启多选模式
     * @default           false
     */
    multiple?: boolean;
    /**
     * @description       错误的传入参数 兼容处理
     * @default           true
     */
    postNo: string | number;
    /**
     * @description       组织参数
     * @default           true
     */
    orgNo: string | number;
    /**
     * @description       底部扩展组件
     */
    footer?: React.ReactNode;
    /**
     * @description       自定义弹窗标准岗位帮助数据请求
     */
    standardPositionsRequest?: (params: IObject) => Promise<{
        list: any[];
        total: number | string;
    }>;
    /**
     * @description       自定义弹窗标准岗位帮助数据请求参数
     */
    standardPositions?: IObject;
    /**
     * @description       弹窗表格列配置
     */
    columns?: IObject[];
}
/**
 * 标准岗位帮助帮助
 */
export declare const StandardPositionsHelp: React.ForwardRefExoticComponent<Omit<IStandardPositionsHelp & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
