/**
 *
 */
import React from 'react';
import { type BaseHelpProps } from '../../functionalComponent';
import { type IObject } from '../../util';
export interface IStaticDicHelp extends BaseHelpProps {
    /**
     * 静态数据字段类型
     */
    typeCode: string;
    /**
     * 静态数据字段父级id
     */
    treePid?: string;
    /**
     * 静态数据的层级深度
     */
    level?: number;
    /**
     * @description       自定义弹出帮助的title
     */
    title: string;
    /**
     * @description       是否开启多选模式
     * @default           false
     */
    multiple?: boolean;
    /**
     * @description       是否只能选末级
     * @default           false
     */
    selectLeafOnly?: boolean;
    /**
     * @description       底部扩展组件
     */
    footer?: React.ReactNode;
    /**
     * @description       表格列配置
     */
    columns?: IObject[];
    /**
     * @description       获取焦点时即加载请求数据
     * @default           false
     */
    loadByFocus?: boolean;
    /**
     * @description       过滤条件{typeCode,treePid,level}
     */
    clientSqlFilter?: IObject | Function;
}
/**
 * 静态数据字典帮助
 */
export declare const StaticDicHelp: React.ForwardRefExoticComponent<Omit<IStaticDicHelp & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const StaticDicHelpSelect: React.ForwardRefExoticComponent<Omit<IStaticDicHelp, "multiple" | "footer" | "modal"> & React.RefAttributes<any>>;
export declare const MultipleStaticDicHelpSelect: React.ForwardRefExoticComponent<Omit<IStaticDicHelp, "multiple" | "footer" | "modal"> & React.RefAttributes<any>>;
