function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { memo, useCallback } from 'react';
import { Table, TableSelectionModel } from "../../../../functionalComponent";
import { Layout, udp } from "../../../../util";
import { QueryPanel } from "../../../query-panel";
import { MasterSlaveSelectEnum } from "../../constants";
import { loadSourceData } from "../../service";
import NoticeIconContent from "./NoticeIconContent";
/**
 * 主子表
 *
 */
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var MasterSlaveTable = function MasterSlaveTable(props) {
  var getRef = props.getRef,
    state = props.state,
    popupMode = props.popupMode,
    flowCode = props.flowCode,
    busData = props.busData,
    dependentState = props.dependentState,
    changeDependent = props.changeDependent,
    rowDisable = props.rowDisable,
    iconVisible = props.iconVisible;

  // 主表数据data
  var tableMainRequest = useCallback(function (defaultParams) {
    return loadSourceData(_objectSpread(_objectSpread({
      flowCode: flowCode,
      busData: busData
    }, defaultParams), {}, {
      popupMode: popupMode,
      sourceId: state === null || state === void 0 ? void 0 : state.masterFormId
    }));
  }, [popupMode, state.masterFormId]);

  // 子表数据data
  var tableRequest = useCallback(function (defaultParams) {
    if (!(dependentState !== null && dependentState !== void 0 && dependentState.length)) {
      return Promise.resolve({
        total: 0,
        list: []
      });
    }
    var sourceId = state.sourceId;
    var newsourceId = sourceId !== null && sourceId !== void 0 && sourceId.indexOf('_') ? udp.split(sourceId, '_')[1] : sourceId;
    return loadSourceData(_objectSpread(_objectSpread({
      flowCode: flowCode,
      busData: busData
    }, defaultParams), {}, {
      popupMode: popupMode,
      sourceId: newsourceId,
      masterId: dependentState.map(function (x) {
        return x.id;
      }).join(',')
    }));
  }, [JSON.stringify(dependentState)]);

  // 搜索框
  var onSearch = function onSearch(_, queryCondition) {
    var _getRef;
    (_getRef = getRef('tableMain')) === null || _getRef === void 0 || (_getRef = _getRef.current) === null || _getRef === void 0 || _getRef.getApi().setExtraParam({
      queryCondition: queryCondition
    });
    changeDependent([]);
  };
  return /*#__PURE__*/_jsxs(Layout, {
    direction: "column",
    children: [state.masterQueryItems.length > 0 && /*#__PURE__*/_jsx(QueryPanel, {
      items: state.masterQueryItems,
      onSearch: onSearch
    }), /*#__PURE__*/_jsx(Layout.Slider, {
      size: 200,
      children: /*#__PURE__*/_jsx(Table, {
        showRowNumber: true,
        columns: state.masterColumns,
        ref: getRef('tableMain'),
        autoLoad: true,
        request: tableMainRequest,
        pagination: {
          hideOnSinglePage: false
        },
        onCheckedChange: function onCheckedChange(selectedRows) {
          changeDependent(selectedRows);
        },
        rowSelection: {
          type: [MasterSlaveSelectEnum.MULTIPLE].includes(state.allowMultiSelect) ? [TableSelectionModel.MULTIPLE_INTERVAL, TableSelectionModel.CHECKBOX] : TableSelectionModel.ROW
        },
        onRow: function onRow(_, __, row) {
          return [MasterSlaveSelectEnum.RADIO, MasterSlaveSelectEnum.ONLY_CHILD_MULTIPLE].includes(state.allowMultiSelect) ? {
            onClick: function onClick() {
              return changeDependent([row]);
            }
          } : {};
        }
      }, state.sourceId)
    }), /*#__PURE__*/_jsx(Layout.Flex, {
      children: /*#__PURE__*/_jsx(NoticeIconContent, {
        iconVisible: iconVisible,
        children: /*#__PURE__*/_jsx(Table, {
          showRowNumber: true,
          columns: state.columns,
          ref: getRef('table'),
          request: tableRequest,
          pagination: {
            hideOnSinglePage: false
          },
          rowSelection: {
            type: [MasterSlaveSelectEnum.MULTIPLE, MasterSlaveSelectEnum.ONLY_CHILD_MULTIPLE].includes(state.allowMultiSelect) ? [TableSelectionModel.MULTIPLE_INTERVAL, TableSelectionModel.CHECKBOX] : TableSelectionModel.ROW,
            disabled: rowDisable
          }
        }, state.sourceId)
      })
    })]
  });
};
export default /*#__PURE__*/memo(MasterSlaveTable);