function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { memo, useCallback } from 'react';
import { Panel, Table, TableSelectionModel } from "../../../../functionalComponent";
import { cssVar, Layout, udp } from "../../../../util";
import { OrgTree } from "../../../org-tree";
import { QueryPanel } from "../../../query-panel";
import { getTreeList, loadSourceData } from "../../service";
import { loopTreeChildren } from "../../utils";
import NoticeIconContent from "./NoticeIconContent";
/**
 * 左树右表
 *
 */
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var TreeTable = function TreeTable(props) {
  var _state$treeFieldConfi;
  var getRef = props.getRef,
    state = props.state,
    popupMode = props.popupMode,
    flowCode = props.flowCode,
    busData = props.busData,
    dependentState = props.dependentState,
    changeDependent = props.changeDependent,
    rowDisable = props.rowDisable,
    iconVisible = props.iconVisible,
    onDataLoad = props.onDataLoad;

  // 表数据data
  var tableRequest = useCallback(function (defaultParams) {
    if (!dependentState) {
      return Promise.resolve({
        total: 0,
        list: []
      });
    }
    var sourceId = state.sourceId;
    var newsourceId = sourceId !== null && sourceId !== void 0 && sourceId.indexOf('_') ? udp.split(sourceId, '_')[1] : sourceId;
    return loadSourceData(_objectSpread(_objectSpread({
      flowCode: flowCode,
      busData: busData
    }, defaultParams), {}, {
      popupMode: popupMode,
      sourceId: newsourceId,
      treeFilterValue: dependentState
    }));
  }, [dependentState]);

  // tree数据data
  var treeRequest = useCallback(function () {
    return getTreeList(state === null || state === void 0 ? void 0 : state.treeFieldConfig);
  }, [JSON.stringify(state.treeFieldConfig)]);

  // 搜索框
  var onSearch = function onSearch(_, queryCondition) {
    var _getRef;
    (_getRef = getRef('table')) === null || _getRef === void 0 || (_getRef = _getRef.current) === null || _getRef === void 0 || _getRef.getApi().setExtraParam({
      queryCondition: queryCondition
    });
  };

  // 搜索树
  var onSelectedChange = function onSelectedChange(_, record) {
    var selectIds = loopTreeChildren(record) || [];
    changeDependent(selectIds.join(','));
  };
  return /*#__PURE__*/_jsxs(Layout.Flex, {
    direction: "row",
    style: {
      height: '100%'
    },
    children: [/*#__PURE__*/_jsxs(Layout.Slider, {
      size: 200,
      style: {
        marginRight: 'var(--inner-margin, 16px)',
        borderRight: cssVar.border
      },
      children: [/*#__PURE__*/_jsx(Panel, {
        title: (state === null || state === void 0 || (_state$treeFieldConfi = state.treeFieldConfig) === null || _state$treeFieldConfi === void 0 ? void 0 : _state$treeFieldConfi.title) || '树',
        autoFit: true
      }), /*#__PURE__*/_jsx(OrgTree, {
        onSelectedChange: onSelectedChange,
        treeRequest: treeRequest
      })]
    }), /*#__PURE__*/_jsxs(Layout.Flex, {
      direction: "column",
      children: [state.queryItems.length > 0 && /*#__PURE__*/_jsx(QueryPanel, {
        items: state.queryItems,
        onSearch: onSearch
      }), /*#__PURE__*/_jsx(NoticeIconContent, {
        iconVisible: iconVisible,
        children: /*#__PURE__*/_jsx(Table, {
          showRowNumber: true,
          columns: state.columns,
          ref: getRef('table'),
          autoLoad: true,
          request: tableRequest,
          pagination: {
            hideOnSinglePage: false
          },
          rowSelection: {
            type: state.allowMultiSelect == 1 ? [TableSelectionModel.MULTIPLE_INTERVAL, TableSelectionModel.CHECKBOX] : TableSelectionModel.ROW,
            disabled: rowDisable
          },
          onDataLoad: onDataLoad
        }, state.sourceId)
      })]
    })]
  });
};
export default /*#__PURE__*/memo(TreeTable);