import { type IObject } from '../../util';
import type { ArrayReturnType, ICheckRuleInfoParams, ICiteSourceParams, IFlowParams, IPushBillParams, IShowFlowInstance, MappingAllDatasParams } from './interface';
export declare const $ImpSdk: {
    /**
     * 业务流帮助
     */
    flowHelp({ bizCode, bizType, orgId, tenantId, title, width, height, contractTypes }: IFlowParams): Promise<ArrayReturnType>;
    /**
     * 引用来源（imp拉）
     */
    citeSource(params: ICiteSourceParams): Promise<ArrayReturnType<IObject>>;
    /**
     * 生成目的单（imp推）
     */
    pushBill(params: IPushBillParams): Promise<ArrayReturnType<string | string[]>>;
    /**
     * 获取推单据数据
     * @param cacheKey 单据数据缓存key
     * @returns
     */
    getPushBillData({ cacheKey, autoFill }?: {
        cacheKey?: string | undefined;
        autoFill?: boolean | undefined;
    }): Promise<IObject>;
    /**
     * 业务流实例查看
     */
    showFlowInstance(params: IShowFlowInstance): void;
    /**
     * 来源引用引用数据时支持不弹出数据选择窗口，直接返回所有数据
  
     */
    mappingAllDatas(params: MappingAllDatasParams): Promise<ArrayReturnType>;
    /**
     * 校验规则提示窗
     */
    showCheckRuleInfo({ dataSource, isView, saveDraft, onContinue, title, width, height }: ICheckRuleInfoParams): Promise<unknown> | "无需弹窗";
    /**
     * 结束待办任务
     * @param params  { taskId: string }
     * @returns
     */
    closeTaskByTaskId(params: {
        taskId: string;
    }): Promise<boolean>;
};
