/// <reference types="react" />
import { IAsyncTreeProps } from '../../functionalComponent';
declare const defaultProps: {
    /**
     * @description       权限
     * @default           true
     */
    dataAccessAuth: boolean;
    orgInnerType: string;
    containLowCu: boolean;
    containDept: boolean;
    containProject: boolean;
    enableManagerContrl: boolean;
    orgNo: string;
};
export type OrgTreeParamType = Partial<typeof defaultProps> & Record<string, any>;
export type OrgTreeType = Omit<IAsyncTreeProps, 'request'> & {
    /**
     * @description       默认选中第一个节点
     * @default           false
     */
    defaultSelectedFirstNode?: boolean;
    /**
     * @description       树的参数
     * @default           {dataAccessAuth: true, orgInnerType: 2, containLowCu: true,  containDept: false,  containProject: false, enableManagerContrl: false}
  }
     */
    params?: OrgTreeParamType;
    beforeRequest?: (...args: any[]) => Promise<boolean | void>;
    treeRequest?: (params: OrgTreeParamType) => Promise<any[]>;
};
/**
 * 导出组织树控件
 */
export declare const OrgTree: import("react").ForwardRefExoticComponent<Omit<Omit<IAsyncTreeProps, "request"> & {
    /**
     * @description       默认选中第一个节点
     * @default           false
     */
    defaultSelectedFirstNode?: boolean | undefined;
    /**
     * @description       树的参数
     * @default           {dataAccessAuth: true, orgInnerType: 2, containLowCu: true,  containDept: false,  containProject: false, enableManagerContrl: false}
  }
     */
    params?: OrgTreeParamType | undefined;
    beforeRequest?: ((...args: any[]) => Promise<boolean | void>) | undefined;
    treeRequest?: ((params: OrgTreeParamType) => Promise<any[]>) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export {};
