export interface PrintParams {
    bacthPrintList?: any;
    batchPrintList: any;
    bizCode: string;
    isBatch?: boolean;
    source_sys?: string;
    id?: string[];
    successCallback?: Function;
    cancelCallback?: Function;
}
export interface IPrintObject {
    /**
     * @description       业务表单ID
     * @default           -
     */
    bizId: string;
    /**
     * @description       业务表单的详情页地址(配置套打数据源接口后url不必传)
     * @default           -
     */
    url?: string;
}
export interface IPrintApi {
    /**
     * @description       业务表单的业务类型编码
     * @default           -
     */
    bizCode: string;
    /**
     * @description       帆软打印表单详细数据（选择帆软需要传）
     * @default           -
     */
    batchPrintList: IPrintObject[];
    /**
     * @description     平台打印表单详情数据（选择平台需要传）
     * @default           -
     */
    id?: string[];
    /**
     * @description       对接系统名，打印模板类型为帆软时须配置，由帆软提供
     * @default           -
     */
    source_sys?: string;
}
