import { ReactNode } from 'react';
export declare const info: {
    alertTitle: string;
    paramError: string;
    selectTemplate: string;
    selectOneData: string;
    noCallBack: string;
    templateCode: string;
    name: string;
    remark: string;
    sharePolicy: string;
    shareTenant: string;
    group: string;
    cu: string;
    org: string;
    previewType: string;
    searchEmptyText: string;
    createPrintTitile: string;
    printError: string;
};
export declare const commonStyle: {
    borderStyle: {
        borderRadius: string;
        border: string;
    };
    backgroundStyle: {
        backgroundColor: string;
    };
};
interface IModal {
    title: string;
    width?: number;
    content: ReactNode;
    okText?: boolean | string;
    cancelText?: boolean | string;
    footerLeft?: ReactNode;
    onOk?: (...args: any[]) => any;
    onCancel?: (...args: any[]) => any;
}
/**
 * 弹窗
 * @param props
 */
export declare function wfModal(props: IModal): Promise<unknown>;
/**
 * 提示框
 * @param title 标题
 * @param content 提示内容
 */
export declare function wfAlert(title: any, content: any): Promise<unknown>;
export declare enum SharePolicyEnum {
    /**
     * 集团共享
     */
    GROUP = 0,
    /**
     * 单元共享
     */
    CU = 1,
    /**
     * 组织私有
     */
    ORG = 2
}
export {};
