import { RefObject } from 'react';
import { IObject } from '../../util';
export interface INGWorkFlowPanelProps {
    /**
     * @description       不配置，则取url地址里面的wfpiid参数
     */
    wfPiId?: string;
    /**
     * @description       不配置，则取url地址里面的wftaskid参数
     */
    wfTaskId?: string;
    /**
     * @description       不配置，则取url地址里面的wfotype参数
     */
    wfOType?: string;
    /**
     * @description       不配置，则取url地址里面的eformCode参数加EFORM前缀
     */
    bizType: string;
    /**
     * @description       不配置，则取url地址里面的otype参数
     * @default           edit
     */
    oType?: 'add' | 'edit' | 'view';
    /**
     * @description       不配置，则取url地址里面的id参数
     */
    bizPhId?: string;
    /**
     * @description       不配置，则取url地址里面的isFromPortal参数
     * @default           false
     */
    isFromPortal?: boolean;
    /**
     * @description       不配置，则取url地址里面的iswftasklist参数
     * @default           false
     */
    refreshTaskList?: boolean;
    /**
     * @description       toolbar的id，用于注入审批按钮
     */
    toolbar: string | RefObject<any>;
    /**
     * @description       高度
     * @default           180
     */
    height: number;
    /**
     * @description       任务办理时，可见的toolbar itemId
     */
    showToolBarItems?: Array<string>;
    /**
     * @description       显示所有toolbar按钮
     * @default           false
     */
    showAllToolBar?: boolean;
    /**
     * @description       调用业务单据保存，如果返回false则终止操作
     */
    bizSaveFn?: () => Promise<boolean>;
    /**
     *    * @description       调用业务单据驳回
     */
    bizRollbackSaveFn?: Function;
    /**
     * @description       自定义组件任务处理函数，并把工作流参数传到服务端，并在服务端调用工作流api
     */
    onTaskComplete?: (compId: any, taskDealInfo: any) => Promise<void>;
    /**
     * @description       设置业务组件附加数据
     */
    getAttachData?: Function;
    taskDealInfo?: IObject;
    /**
     * @description     判断办理组件是横板还是竖版
     */
    direction?: 'vertical' | 'horizontal';
    slider?: boolean;
}
/**
 * 审批办理中间组件（验证参数、请求审批信息数据）
 * @param props
 * @constructor
 */
declare function WorkFlowPanel(props: INGWorkFlowPanelProps): import("react/jsx-runtime").JSX.Element | null;
declare namespace WorkFlowPanel {
    var defaultProps: {
        oType: string;
        height: number;
        slider: boolean;
        showToolBarItems: never[];
        bizType: string;
        bizPhId: string;
        isFromPortal: boolean;
        refreshTaskList: boolean;
        bizSaveFn: () => void;
        bizRollbackSaveFn: () => void;
        getAttachData: () => void;
        showAllToolBar: boolean;
        taskDealInfo: {};
        direction: string;
    };
}
export default WorkFlowPanel;
