import { IResponse } from '../../util';
export interface WorkFlowHisData {
    taskId: string;
    procInstId: string;
    parentTaskId: string;
    bizOperation: string;
    bizApproved: boolean;
    preRollbackBizCheck: boolean;
    multiInstanceTask: boolean;
    initiateUserTask: boolean;
    mustUploadBizAttachment: boolean;
    mustUploadApprovalAttachment: boolean;
    allowCarbonCopy: boolean;
}
/**
 * 审批界面获取工作流信息
 * @param wfPiId
 * @param wfTaskId
 * @param wfOType
 */
export declare function getWorkFlowInfo({ wfPiId, wfTaskId, wfOType, copyId, nodeDefKey }: {
    wfPiId: any;
    wfTaskId: any;
    wfOType: any;
    copyId: any;
    nodeDefKey: any;
}): Promise<any>;
/**
 * 获取流程历史
 * @param procInstId
 */
export declare function getWorkFlowHis({ procInstId }: {
    procInstId: any;
}): Promise<any>;
/**
 * 获取常用语关键词
 */
export declare function getCommonWordHelp(): Promise<any>;
/**
 * 创建-更新常用语
 * @param content
 * @param id
 */
export declare function createOrUpdateContent(content: any, id?: any): Promise<IResponse>;
/**
 * 常用语删除
 * @param contentId
 */
export declare function deleteContentById(contentIds: any): Promise<boolean>;
/**
 * 获取签章数据源
 */
export declare function getSignatureListByCurrentUser(): Promise<any>;
/**
 * 验证签章信息
 * @param PhId
 * @param pwd
 */
export declare function validSignatureInfoByPassword({ PhId, pwd }: {
    PhId: any;
    pwd: any;
}): Promise<boolean>;
export declare function updateNotificationReadFlg({ piId }: {
    piId: any;
}): void;
/**
 * 保存审批意见区宽度
 * @param width 意见区宽度
 * @constructor
 */
export declare function saveRemarkPanelWidth(width: any): void;
/**
 * 获取发起节点属性
 * @param processDefinitionId 流程Id
 * @constructor 获取是否签章和最少意见数，原来是放在流程定义列表里面的，现在单独一个接口来获取。
 */
export declare function getProcessInitialActivity(processDefinitionId: any): Promise<any>;
export declare function checkPreStartProcessInstance(params: any): Promise<IResponse>;
export declare function checkPreRollback(taskId: any): Promise<IResponse>;
/**
 * 获取回退信息
 * @param taskId 任务id
 */
export declare function getRollBackInfo(taskId: any): Promise<any>;
export declare function RollBack(params: any): Promise<IResponse>;
/**
 * 加签
 * @param params 包含任务id
 */
export declare function addSubTaskAsync(params: any): Promise<IResponse>;
export declare function checkPreCompleteTask(taskId: any): Promise<IResponse>;
export declare function compeleteTask(params: any): Promise<IResponse>;
interface CarbonCopyResponse<T> extends IResponse {
    data: T;
}
/** @description  抄送*/
export declare function carbonCopy(taskId: string, userNos: string[], appCode?: string): Promise<CarbonCopyResponse<{
    data: boolean;
}>>;
export declare function getToDoInfo(taskId: any): Promise<any>;
/**
 * @description 获取已办节点信息
 */
export declare function getCompletedNodeInfo(params: any): Promise<any>;
/**
 * @description 获取待办节点信息
 */
export declare function getUnHandledNodeInfo(params: any): Promise<any>;
export declare function getSignatureByUser(): Promise<any>;
/**
 * @description 获取下一人工任务节点
 */
export declare function getNextUserTaskNodes(taskId: any): Promise<any>;
export {};
