/// <reference types="react" />
import { LayConfWrap } from '../util';
import { Comp_Props } from './config/interface';
export { LayConfWrap };
export type OptType = 'modifiedRow' | 'newRow' | 'deletedRow';
/**
 * 根据配置数据获取对应配置的组件
 * @param {object} item 组件配置项
 * @returns {object} 组件
 */
export declare function getComp(item: any): {
    instance: string | import("react").ComponentType<any>;
    props: Record<string, any> | undefined;
} | {
    instance: any;
    props: import("@cscec/udp-core/src/interface/types/ts.lib").IObject;
} | {
    instance: any;
};
/**
 * 获取组件对应的配置
 * @returns {object} 组件的配置props
 * @param item
 * @param config
 */
export declare function getCompPorps(item: any, config: Comp_Props): any;
/**
 * 格式化数据
 * @param name
 * @param type
 * @param opt
 * @param key
 * @param initVals
 */
export declare function fomatValues(name: string, type: 'form' | 'table', opt: OptType, key: string, initVals?: any): (values?: any) => (() => {}) | any;
export declare function formFomatValues(key: string, initVals?: Array<any>): ((values?: any) => (() => {}) | any) | {
    form: {
        [x: string]: any;
        key: string;
    };
};
export declare function listToObj(c: Array<any>): any;
export declare function getProperty(o: any, keys: string | number | Array<string | number>): any;
export declare function parseFunction(str: any): any;
export declare function getObjValue(obj: any, pathKeys: any): any;
export declare function setObjValue(obj: any, pathKeys: any, value: any): void;
export declare function getSubscribeFn(outRef: any): (fn: Function, type: any, name?: string | string[]) => any;
export declare function isHelpField(type: any): any;
export declare function isValueLabel(item: any): boolean;
export declare function convertHelpValues(initValues: any): any;
