import { DirectoryTreeProps } from 'antd/es/tree';
import { TreeSelectProps } from 'antd/es/tree-select';
import { CSSProperties } from 'react';
/**
 * 加载树组件时的骨架
 * @param row 显示骨架行数，默认4
 * @param style
 * @constructor
 */
declare function TreeLoading({ row, style }: {
    row?: number;
    style?: CSSProperties;
}): import("react/jsx-runtime").JSX.Element;
export interface TreeProps extends DirectoryTreeProps {
    /**
     * @description       节点不允许换行，超出自动隐藏
     * @default           true
     */
    nowrap?: boolean;
    /**
     * @description       是否开启虚拟滚动
     * @default           true
     */
    virtual?: boolean;
    /**
     * @description       是否显示目录树
     * @default           true
     */
    directoryTree?: boolean;
    /**
     * @description       是否行选中复选框（多选模式下有效）
     * @default           false
     */
    rowChecked?: boolean;
}
declare const Tree: import("react").ForwardRefExoticComponent<Omit<TreeProps & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
declare const TreeSelect: import("react").ForwardRefExoticComponent<Omit<TreeSelectProps<any, import("rc-tree-select/lib/TreeSelect").DefaultOptionType> & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export { TreeLoading, TreeSelect, Tree };
