var _excluded = ["outRef", "height", "nowrap", "virtual", "className", "directoryTree", "rowChecked"],
  _excluded2 = ["outRef"];
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { Skeleton, Tree as AntTree, TreeSelect as AntTreeSelect } from 'antd';
import { useState } from 'react';
import { compHoc, cssVar, udp, useRefCallback } from "../../util";
import { AutoResize } from "../../widgets";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var DirectoryTree = AntTree.DirectoryTree;

/**
 * 加载树组件时的骨架
 * @param row 显示骨架行数，默认4
 * @param style
 * @constructor
 */
function TreeLoading(_ref) {
  var _ref$row = _ref.row,
    row = _ref$row === void 0 ? 4 : _ref$row,
    style = _ref.style;
  return /*#__PURE__*/_jsxs("div", {
    style: _objectSpread({
      padding: 5
    }, style),
    children: [/*#__PURE__*/_jsx(Skeleton, {
      active: true,
      paragraph: {
        rows: 1
      },
      title: false
    }), /*#__PURE__*/_jsx("div", {
      style: {
        paddingLeft: 20
      },
      children: /*#__PURE__*/_jsx(Skeleton, {
        active: true,
        paragraph: {
          rows: row
        },
        title: false
      })
    })]
  });
}
var Tree = compHoc(function (_ref2) {
  var outRef = _ref2.outRef,
    height = _ref2.height,
    _ref2$nowrap = _ref2.nowrap,
    nowrap = _ref2$nowrap === void 0 ? true : _ref2$nowrap,
    _ref2$virtual = _ref2.virtual,
    virtual = _ref2$virtual === void 0 ? true : _ref2$virtual,
    className = _ref2.className,
    _ref2$directoryTree = _ref2.directoryTree,
    directoryTree = _ref2$directoryTree === void 0 ? true : _ref2$directoryTree,
    _ref2$rowChecked = _ref2.rowChecked,
    rowChecked = _ref2$rowChecked === void 0 ? false : _ref2$rowChecked,
    props = _objectWithoutProperties(_ref2, _excluded);
  var _useState = useState(height),
    _useState2 = _slicedToArray(_useState, 2),
    treeHeight = _useState2[0],
    setTreeHeight = _useState2[1];
  var _useState3 = useState(props.defaultSelectedKeys || []),
    _useState4 = _slicedToArray(_useState3, 2),
    selectedKeys = _useState4[0],
    setSelectedKeys = _useState4[1];
  var onResize = useRefCallback(function (_ref3) {
    var height = _ref3.height;
    setTreeHeight(height);
  });
  var extraProps = {};
  if (rowChecked) {
    extraProps.onSelect = function (keys, info) {
      var _props$onSelect;
      var eventNode = info.node;
      if (props.checkable && eventNode && !eventNode.disabled && eventNode.checkable !== false && !eventNode.disableCheckbox) {
        outRef.current.onNodeCheck({}, info.node, true);
      }
      (_props$onSelect = props.onSelect) === null || _props$onSelect === void 0 || _props$onSelect.call(props, keys, info);
    };
  }

  // 单选模式关联取消选中
  if (!props.checkable && directoryTree) {
    extraProps.onSelect = function (keys, info) {
      var _props$onSelect2;
      var realKeys = JSON.stringify(keys) === JSON.stringify(selectedKeys) ? [] : keys;
      var realInfo = JSON.stringify(keys) === JSON.stringify(selectedKeys) ? Object.assign({}, info, {
        selectedNodes: [],
        node: {}
      }) : info;
      setSelectedKeys(realKeys);
      (_props$onSelect2 = props.onSelect) === null || _props$onSelect2 === void 0 || _props$onSelect2.call(props, realKeys, realInfo);
    };
    extraProps.selectedKeys = selectedKeys;
  }
  var RenderTree = directoryTree ? DirectoryTree : AntTree;
  if (virtual) {
    return /*#__PURE__*/_jsx("div", {
      className: udp.classNames('virtual-tree', {
        'udp-tree-nowrap': nowrap
      }, className),
      style: {
        height: height || '100%',
        overflow: "hidden",
        width: '100%',
        minHeight: 60,
        position: 'relative',
        backgroundColor: cssVar.componentColor
      },
      children: height ? /*#__PURE__*/_jsx(RenderTree, _objectSpread(_objectSpread(_objectSpread({
        ref: outRef,
        expandAction: "doubleClick",
        blockNode: true
      }, props), extraProps), {}, {
        height: height
      })) : /*#__PURE__*/_jsx(AutoResize, {
        onResize: onResize,
        children: !!treeHeight && /*#__PURE__*/_jsx(RenderTree, _objectSpread(_objectSpread(_objectSpread({
          ref: outRef,
          expandAction: "doubleClick",
          blockNode: true
        }, props), extraProps), {}, {
          height: treeHeight
        }))
      })
    });
  }
  return /*#__PURE__*/_jsx("div", {
    className: udp.classNames({
      'udp-tree-nowrap': nowrap
    }, className),
    style: {
      height: height || '100%',
      width: '100%',
      position: 'relative',
      overflow: 'auto'
    },
    children: /*#__PURE__*/_jsx(RenderTree, _objectSpread(_objectSpread({
      ref: outRef,
      expandAction: "doubleClick",
      blockNode: true,
      virtual: false
    }, props), extraProps))
  });
});
var TreeSelect = compHoc(function (_ref4) {
  var outRef = _ref4.outRef,
    props = _objectWithoutProperties(_ref4, _excluded2);
  return /*#__PURE__*/_jsx(AntTreeSelect, _objectSpread({
    ref: outRef
  }, props));
});
export { TreeLoading, TreeSelect, Tree };