import React, { CSSProperties } from 'react';
import './index.less';
export interface IFullPageProps {
    children: React.ReactNode;
    iconStyle?: CSSProperties;
    style?: CSSProperties;
    innerStyle?: CSSProperties;
    /**
     * @description   是否显示icon图标
     * @default       true
     */
    showIcon?: boolean;
    /**
     * @description   是否常驻icon图标，showIcon=true 时有效
     * @default       false
     */
    residentIcon?: boolean;
    /**
     * @description   全屏的dom层级
     * @default       99
     */
    zIndex?: number;
    className?: string;
    /**
     * @description   自定义全屏按钮所在的容器
     */
    getIconContainer?(): HTMLElement | null;
    /**
     * @description   全屏切换后回调
     */
    onFullScreen?(full: boolean): void;
    /**
     * @description   全屏撑满的容器
     * @default       整个窗口或子应用窗口
     */
    getFullContainer?(): HTMLElement | null;
}
export declare const FullPage: React.ForwardRefExoticComponent<IFullPageProps & React.RefAttributes<{
    setFullPage(full: boolean): void;
}>>;
