function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useContext, useEffect, useRef, useState } from 'react';
import { TableContext } from "../base/common";
import { stopPropagation } from "../util";

/**
 * 展开折叠按钮
 * @param row
 * @param rowIndex
 * @param icon
 * @param style
 * @constructor
 */
import { jsx as _jsx } from "react/jsx-runtime";
export var ExpandIcon = /*#__PURE__*/React.memo(function (_ref) {
  var row = _ref.row,
    rowIndex = _ref.rowIndex,
    icon = _ref.icon,
    _ref$style = _ref.style,
    style = _ref$style === void 0 ? {} : _ref$style;
  var _useContext = useContext(TableContext),
    table = _useContext.table;
  var expandField = table.getExpandField();
  var spanRef = useRef(null);
  var _useState = useState(row[expandField]),
    _useState2 = _slicedToArray(_useState, 2),
    expand = _useState2[0],
    setExpand = _useState2[1];
  var switchExpand = function switchExpand(e) {
    stopPropagation(e);
    setExpand(!expand);
    table.setExpand(rowIndex, !expand);
  };
  useEffect(function () {
    setExpand(row[expandField]);
  }, [row[expandField]]);
  if (icon) {
    return /*#__PURE__*/_jsx("span", {
      ref: spanRef,
      className: "row-expand-icon",
      style: style,
      onClick: switchExpand,
      children: icon(expand)
    });
  }
  return /*#__PURE__*/_jsx("span", {
    ref: spanRef,
    className: "default-icon row-expand-icon",
    style: style,
    onClick: switchExpand,
    children: /*#__PURE__*/_jsx("span", {
      className: "".concat(expand ? ' row-expand-icon-expanded' : '')
    })
  });
});