function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useMemo, useRef, useState } from 'react';
import { useUdpEffect, useRefCallback, util } from "../util";
export function useValue(value, isHelp) {
  var ref = useRef({
    value: value,
    forceUpdate: false
  });
  var _useState = useState({
      value: value
    }),
    _useState2 = _slicedToArray(_useState, 2),
    forceUpdate = _useState2[0],
    setForceUpdate = _useState2[1];
  useMemo(function () {
    var oldValue = ref.current.value;
    if (isHelp && (util.isObject(oldValue) || util.isArray(oldValue))) {
      var _oldValue$value;
      var tmp = util.isArray(oldValue) ? oldValue.map(function (v) {
        var _v$value;
        return (_v$value = v.value) !== null && _v$value !== void 0 ? _v$value : v;
      }).join(',') : (_oldValue$value = oldValue.value) !== null && _oldValue$value !== void 0 ? _oldValue$value : oldValue;
      if (tmp === value) {
        return;
      }
    }
    ref.current.value = value;
    ref.current.forceUpdate = true;
  }, [value, isHelp]);
  var update = useRefCallback(function (newValue, callback, _forceUpdate) {
    ref.current.value = newValue;
    ref.current.callback = callback;
    if (_forceUpdate || ref.current.value !== forceUpdate.value || ref.current.forceUpdate) {
      ref.current.forceUpdate = false;
      setForceUpdate({
        value: newValue
      });
    }
  });
  useUdpEffect(function () {
    var _ref$current$callback, _ref$current;
    (_ref$current$callback = (_ref$current = ref.current).callback) === null || _ref$current$callback === void 0 || _ref$current$callback.call(_ref$current, forceUpdate.value);
  }, [forceUpdate], false);
  return [ref.current.value, update];
}