import { type IObject } from '../../util';
/**
 * 定义业务数据接口类型
 */
interface IBussData extends IObject {
    /**
     * @description      业务类型
     */
    busType?: string;
    /**
     * @description      单据(列表页面为当前选中数据行)数据状态
     */
    data?: IObject;
    /**
     * @description      物理主键字段
     * @default          'phid'
     */
    keyField?: string | string[];
    /**
     * @description       单据编码字段
     * @default           'bill_no'
     */
    billNoField?: string;
    /**
     * @description       单据名称字段
     * @default           'bill_name'
     */
    billNameField?: string;
    /**
     * @description       单据日期字段
     * @default           'bill_dt'
     */
    billDtField?: string;
    /**
     * @description      所属项目字段
     * @default          'phid_pc'
     */
    projectField?: string;
    /**
     * @description      所属组织字段
     * @default          'phid_org'
     */
    orgField?: string;
    /**
     * @description      所属部门字段
     * @default          'phid_dept'
     */
    deptField?: string;
    /**
     * @description      附件标志字段
     * @default          'asr_flag'
     */
    asrField?: string;
    /**
     * @description      工作流状态字段
     * @default          'wf_flag'
     */
    wfField?: string;
    /**
     * @description      审核状态字段
     * @default          'app_status'
     */
    appField?: string;
    /**
     * @description      审核人字段
     * @default          'phid_app'
     */
    approverField?: string;
    /**
     * @description      审核时间字段
     * @default          'app_dt'
     */
    appDtField?: string;
    /**
     * @description      归档状态字段
     * @default          'arc_flag'
     */
    arcField?: string;
    /**
     * @description      记账状态字段
     * @default          'tr_flag'
     */
    trField?: string;
    /**
     * @description      IMP方案id字段
     * @default          'phid_schemeid'
     */
    schemeIdField?: string;
}
export type BussDataType = (params: {
    id: string;
}) => Promise<IBussData> | IBussData;
/**
 * 处理toolbar按钮事件
 * @param payload
 */
export declare function handleClick(payload: any): Promise<any>;
export {};
