var _excluded = ["chainWebpack", "headScripts", "mfsu"],
  _excluded2 = ["shared"];
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function mergeConfig(defaultCfg, cfg) {
  Object.keys(cfg).forEach(function (key) {
    if (Object.prototype.toString.call(cfg[key]) === '[object Object]') {
      defaultCfg[key] = _objectSpread(_objectSpread({}, defaultCfg[key]), cfg[key]);
    } else {
      defaultCfg[key] = cfg[key];
    }
  });
  return defaultCfg;
}

/**
 * 配置umi.ts
 * @param config
 */
export function initUmiConfig() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var chainWebpack = config.chainWebpack,
    _config$headScripts = config.headScripts,
    headScripts = _config$headScripts === void 0 ? [] : _config$headScripts,
    mfsu = config.mfsu,
    others = _objectWithoutProperties(config, _excluded);
  var publicPath = process.env.NODE_ENV === 'production' ? './' : '/';
  var _ref = mfsu || {},
    shared = _ref.shared,
    mfsuCfg = _objectWithoutProperties(_ref, _excluded2);
  var productionConfig = mergeConfig({
    runtimePublicPath: {},
    publicPath: publicPath,
    headScripts: ["window.publicPath=window.__INJECTED_PUBLIC_PATH_BY_QIANKUN__||'".concat(publicPath, "';")].concat(_toConsumableArray(headScripts)),
    base: '/',
    ignoreMomentLocale: true,
    history: {
      type: 'hash'
    },
    model: {},
    antd: {
      import: false
    },
    request: false,
    initialState: {},
    locale: {
      antd: true,
      default: 'zh-CN'
    },
    mock: {},
    layout: false,
    dva: {
      skipModelValidate: true,
      lazyLoad: true
    },
    mfsu: _objectSpread({
      shared: _objectSpread({
        react: {
          singleton: true
        },
        'react-dom': {
          singleton: true
        },
        dva: {
          singleton: true
        },
        '@cscec/udp-core': {
          singleton: true
        },
        '@cscec/udp-ui': {
          singleton: true
        }
      }, shared),
      strategy: 'eager'
    }, mfsuCfg)
  }, others);
  if (process.env.NODE_ENV === 'production') {
    productionConfig.hash = true;
    productionConfig.chainWebpack = function (config, options) {
      var CompressionWebpackPlugin = require('compression-webpack-plugin');
      config.plugin('compression-webpack-plugin').use(new CompressionWebpackPlugin({
        algorithm: 'gzip',
        // 指定生成gzip格式
        test: /\.(js|css|json|txt|html|ico|svg)(\?.*)?$/i,
        // 匹配哪些格式文件需要压缩
        threshold: 10240,
        //对超过10k的数据进行压缩
        minRatio: 0.6 // 压缩比例，值为0 ~ 1
      }));
      chainWebpack && chainWebpack(config, options);
    };
  } else {
    if (!productionConfig.chainWebpack && chainWebpack) {
      productionConfig.chainWebpack = chainWebpack;
    }
  }
  return productionConfig;
}