function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { App, ConfigProvider, Spin } from 'antd';
import zhCN from 'antd/es/locale/zh_CN';
import 'dayjs/locale/zh-cn';
import React, { useEffect, useLayoutEffect, useMemo, useRef, useState } from 'react';
import { InjectModalCtx } from "../functionalComponent";
import { AppEntry, defaultTheme, getCurrentWindow, getGlobalContainer, initCustomThemeColor, udp, useQkState, WaterMark } from "../util";
import "./base.less";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
/**
 * 初始化默认主题
 */
function useDefaultTheme() {
  var themeRef = useRef();
  getCurrentWindow()['__env__'] = 'pc';
  useLayoutEffect(function () {
    if (!themeRef.current) {
      var _defaultTheme$antdThe;
      themeRef.current = {
        primaryColor: ((_defaultTheme$antdThe = defaultTheme.antdTheme.token) === null || _defaultTheme$antdThe === void 0 ? void 0 : _defaultTheme$antdThe.colorPrimary) || '#008EE0'
      };
      initCustomThemeColor(themeRef.current.primaryColor, {
        env: 'pc',
        theme: defaultTheme
      });
    }
  }, []);
}

/**
 * 根组件
 * @param children
 * @param componentSize
 * @param spinProps
 * @param waterMark 水印
 * @constructor
 */
export function RootContainer(_ref) {
  var children = _ref.children,
    componentSize = _ref.componentSize,
    spinProps = _ref.spinProps,
    waterMark = _ref.waterMark,
    configProvider = _ref.configProvider;
  var _useState = useState({
      spinning: false
    }),
    _useState2 = _slicedToArray(_useState, 2),
    loadingState = _useState2[0],
    setLoadingState = _useState2[1];
  var waterMarkProps = waterMark === true ? {} : _objectSpread({}, waterMark);
  var qkInfo = useQkState();
  useDefaultTheme();

  // useMemo 注入属性同步进行，保证子组件能够正常拿到接口数据
  useMemo(function () {
    // qiankun 子应用子应用内 HTMLElement 对象被代理了, 导致 DOM对象 instanceof HTMLElement 返回了false。
    HTMLElement = new Function('return this')().HTMLElement;
    udp.registerExternal({
      getQianKun: function getQianKun() {
        return qkInfo;
      }
    });
  }, [qkInfo]);
  useEffect(function () {
    udp.registerExternal({
      maskLoading: function maskLoading() {
        var parmas = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        setLoadingState(function (p) {
          return parmas ? _objectSpread(_objectSpread({}, p), {}, {
            spinning: true
          }, parmas) : _objectSpread(_objectSpread({}, p), {}, {
            spinning: false
          });
        });
      },
      getWaterMark: function getWaterMark() {
        var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        return waterMark && /*#__PURE__*/_jsx(WaterMark, _objectSpread(_objectSpread({}, waterMark === true ? {} : waterMark), options));
      }
    });
  }, [waterMark]);
  return /*#__PURE__*/_jsx(ConfigProvider, _objectSpread(_objectSpread({
    getPopupContainer: getGlobalContainer,
    locale: zhCN,
    componentSize: componentSize,
    theme: defaultTheme.antdTheme
  }, configProvider), {}, {
    children: /*#__PURE__*/_jsxs(App, {
      style: {
        height: '100%'
      },
      children: [children, /*#__PURE__*/_jsx(InjectModalCtx, {}), /*#__PURE__*/_jsx(AppEntry, {}), /*#__PURE__*/_jsx("div", {
        children: loadingState.spinning && /*#__PURE__*/_jsx(Spin, _objectSpread(_objectSpread(_objectSpread({}, spinProps), loadingState), {}, {
          spinning: true,
          className: udp.classNames('udp-body-loading', loadingState.className)
        }))
      }, "loading"), waterMark && /*#__PURE__*/_jsx(WaterMark, _objectSpread({}, waterMarkProps))]
    })
  }));
}