var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/baseComponent/combobox.tsx
var combobox_exports = {};
__export(combobox_exports, {
  Combobox: () => Combobox
});
module.exports = __toCommonJS(combobox_exports);
var import_antd = require("antd");
var import_util = require("../util");
var Combobox = (0, import_util.compHoc)(
  class extends import_util.UdpComponent {
    constructor(props) {
      super(props);
      this.onHandlerChange = (e) => {
        const value = this.labelInValue(e);
        if (this.props.hasOwnProperty("value")) {
          this.state.value = value;
          this.props.onChange && this.props.onChange(value);
        } else {
          this.setValue(value);
        }
        this.innerNotify([value], "onChange").then();
      };
      this.state.value = props.defaultValue;
    }
    static getDerivedStateFromProps(nextProps, prevState) {
      return import_util.UdpComponent.propsToState(nextProps, prevState, ["value"]);
    }
    setValue(val, cb) {
      if (this.state.value === val) {
        return;
      }
      const value = this.labelInValue(val);
      this.setState(
        (prev) => ({ ...prev, value }),
        () => {
          this.props.onChange && this.props.onChange(value);
          cb && cb(value);
        }
      );
    }
    getValue() {
      const v = this.state.value;
      if ((v == null ? void 0 : v.value) === void 0) {
        return v;
      }
      return v.value;
    }
    getRawValue() {
      return this.labelInValue(this.state.value);
    }
    getText() {
      var _a;
      return (_a = this.getRawValue()) == null ? void 0 : _a.label;
    }
    labelInValue(val) {
      if (import_util.udp.isNullOrEmpty(val)) {
        return void 0;
      }
      const value = val.value ?? val;
      return this.props.options.find((o) => o.value === value) ?? { value, label: value };
    }
    render() {
      const { value, onChange, showSearch, observer, ...others } = this.props;
      return /* @__PURE__ */ React.createElement(
        import_antd.AutoComplete,
        {
          ref: this.outRef,
          ...others,
          filterOption: (inputValue, option) => {
            if (import_util.udp.isString(option == null ? void 0 : option.label)) {
              return (option == null ? void 0 : option.label.toUpperCase().indexOf(inputValue.toUpperCase())) !== -1;
            }
            return false;
          },
          showSearch: false,
          value: this.getText(),
          onChange: this.onHandlerChange
        }
      );
    }
  },
  "Combobox"
);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Combobox
});
