/// <reference types="react" />
import { UploadFile, UploadProps as OriginUploadProps } from 'antd';
export interface chunkData {
    file: Blob;
    chunkNumber: number;
    chunkSize: number;
    currentChunkSize: number;
    totalChunks: number;
    totalSize: number;
    md5: string;
    fileName: string;
}
export interface ProgressData {
    fileName: string;
    fileSize: number;
    percent: number;
    uploadedSize: number;
    status: UploadFile['status'] | 'fail';
}
declare const defaultUploadState: {
    success: number;
    fail: number;
    error: number;
    all: number;
    progress: Record<string, ProgressData>;
};
export interface UploadProps extends Pick<OriginUploadProps, 'onRemove' | 'listType' | 'fileList' | 'showUploadList' | 'previewFile' | 'onPreview' | 'disabled'> {
    accept?: string;
    hidden?: boolean;
    children?: React.ReactNode;
    containerStyles?: React.CSSProperties;
    onBeforeUpload?: (file: File, fileList: File[]) => Promise<boolean>;
    onUploaded?: (file: File) => void;
    onUploadStateChange: (data: typeof defaultUploadState, uploading: boolean) => void;
}
export declare const Upload: import("react").ForwardRefExoticComponent<UploadProps & import("react").RefAttributes<{}>>;
export {};
