import { attachDeleteParams, attachLabelSaveParams, attachListDataRes, attachSaveParams, createZipParams, downloadFileParams, getAttachListParams, getDownLoadHistoryParams, getPreviewUrlParams, getTempAttachmentParams, getZipDownloadInfoParams, tableAttachSaveRemarkParams, uploadFileParams } from './type';
export declare function tableAttachInit(data: getAttachListParams, cancelId?: string): Promise<attachListDataRes>;
/**
 * 获取临时附件
 */
export declare function getTempAttachment(data: getTempAttachmentParams): Promise<{
    approved: number;
    asrFid: string;
    asrName: string;
    asrFlag: number;
    asrRemark: string;
    asrSize: string;
    originFileSize: number;
    userName: string;
    asrFilldt: Date;
    userId: string;
    asrTable: string | undefined;
    asrCode: string;
    label: string[] | undefined;
}[]>;
/**
 * 文件分片上传
 */
export declare function uploadFile(data: uploadFileParams): Promise<any>;
export declare function richUploadFile(data: uploadFileParams, userToken?: string): Promise<any>;
/**
 * 获取文件链接
 */
export declare function getPreviewUrl(data: getPreviewUrlParams): Promise<any>;
/**
 * 下载文件
 */
export declare function getDownloadFileUrl(data: downloadFileParams): Promise<any>;
/**
 * 附件上传接口（分块上传，分块大小1M）
 */
export declare function attachUpload(data: any, dbToken?: any): Promise<any>;
/**
 * 附件删除接口
 */
export declare function attachDelete(data: attachDeleteParams): Promise<import("@cscec/udp-core/src/interface/types/IRequestOptions").IResponse | null>;
/**
 * 附件保存接口
 */
export declare function attachSave(data: attachSaveParams[]): Promise<any>;
/**
 * 附件获取下载信息接口（调用下载接口前调用）
 */
export declare function attachGetDownloadInfo(data: any, dbToken?: any): Promise<any>;
/**
 * 附件下载接口
 */
export declare function attachDownload(data: any, dbToken?: any): Promise<any>;
/**
 * 附件获取下载水印文件信息接口（下载水印文件接口前调用）
 */
export declare function attachGetDownloadWaterMarkInfo(data: any, dbToken?: any): Promise<any>;
/**
 * 附件下载水印接口
 */
export declare function attachDownloadWaterMarkFile(data: any, dbToken?: any): Promise<any>;
/**
 * 获取水印内容接口
 */
export declare function attachGetWaterMarkContent(data: any, dbToken?: any): Promise<any>;
/**
 * 表格附件修改备注接口
 */
export declare function tableAttachSaveRemark(data: tableAttachSaveRemarkParams): Promise<import("@cscec/udp-core/src/interface/types/IRequestOptions").IResponse | null>;
/**
 * 附件修改标签接口
 */
export declare function saveAttachLabel(data: attachLabelSaveParams): Promise<import("@cscec/udp-core/src/interface/types/IRequestOptions").IResponse | null>;
/**
 * 工作流附件取数参数获取接口
 */
export declare function getTaskAttachmentParams(data: any, dbToken?: any): Promise<any>;
/**
 * 来源单据附件取数参数获取接口
 */
export declare function getBillSourceAttachmentParams(data: any, dbToken?: any): Promise<any>;
/**
 * 获取下载记录接口
 */
export declare function getDownLoadList(data: getDownLoadHistoryParams): Promise<any>;
/**
 * 保存标签接口
 */
export declare function saveTags(data: any, dbToken?: any): Promise<any>;
/**
 * 共享保存接口
 */
export declare function shareSave(data: any, dbToken?: any): Promise<any>;
/**
 * 创建打包任务接口
 */
export declare function createZip(data: createZipParams): Promise<any>;
/**
 * 获取压缩包下载信息接口
 */
export declare function getZipDownloadInfo(data: getZipDownloadInfoParams): Promise<any>;
/**
 * 修改分类接口
 */
export declare function editCategory(data: any, dbToken?: any): Promise<any>;
/**
 * 获取附件预览列表
 */
export declare function getPreviewAttachmentList(data: any, dbToken?: any): Promise<any>;
/**
 * 获取单据审批流状态
 */
export declare function getAttachmentAuditStatus(data: any, dbToken?: any): Promise<any>;
/**
 * 获取单据审批流状态
 */
export declare function getAttachmentCountBatch(data: any, dbToken?: any): Promise<any>;
export declare function mergeChunks(data: {
    cursorId: string;
    totalChunks: number;
    md5: string;
    busiType: string;
}): Promise<{
    fileId: string | undefined;
    failedChunks: number[] | undefined;
}>;
