import React from 'react';
import { BaseHelpProps } from '../../functionalComponent';
import { IObject } from '../../util';
interface metricsParamType {
    pageNum: number;
    pageSize: number;
    queryfilter?: {};
    metricTreeId?: number;
    metricName?: string;
    bizPrincipal?: string;
    clientSqlFilter?: string | IObject | (({ ds, row, value, dataIndex, helpId }: {
        ds: Array<any>;
        row: any;
        value: any;
        dataIndex: string;
        helpId: string;
    }) => string | IObject);
}
interface BaseMetricsHelp extends BaseHelpProps {
    /**
     * @description
     */
    displayField?: string;
    /**
     * @description       自定义弹出帮助的title
     */
    title?: string;
    /**
     * @description       是否开启多选模式
     * @default           false
     */
    multiple?: boolean;
    /**
     * @description       底部扩展组件
     */
    footer?: React.ReactNode;
    /**
     * @description       表格列配置
     */
    columns?: IObject[];
    /**
     * @description       物资列表参数
     */
    metricsParams?: metricsParamType;
    /**
     * @description       自定义指标请求
     */
    metricsRequest?: (params: metricsParamType | undefined) => Promise<{
        list: any[];
        total: number | string;
    }>;
    /**
     * @description   查询参数
     */
    clientSqlFilter?: string | IObject | (({ ds, row, value, dataIndex }: {
        ds: Array<any>;
        row: any;
        value: any;
        dataIndex: string;
        helpId: string;
    }) => string | IObject);
}
export type IMetricsHelp = BaseMetricsHelp;
/**
 * 指标帮助
 */
export declare const MetricsHelp: React.ForwardRefExoticComponent<Omit<BaseMetricsHelp & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export default MetricsHelp;
