var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/help/MultipleHelp.tsx
var MultipleHelp_exports = {};
__export(MultipleHelp_exports, {
  MultipleHelp: () => MultipleHelp,
  MultipleHelpSelect: () => MultipleHelpSelect
});
module.exports = __toCommonJS(MultipleHelp_exports);
var import_react = __toESM(require("react"));
var import_functionalComponent = require("../../functionalComponent");
var import_util = require("../../util");
var import_common = require("./common");
var { Header, Footer, MultipleButtons } = import_functionalComponent.BaseHelp;
var tableProps = {
  checkbox: "checked",
  rowChecked: true,
  headerMenu: false,
  rowSelected: false,
  style: { borderStyle: "solid", borderColor: "var(--border-color-split, #f0f0f0)", borderWidth: 1 }
};
function HelpContent() {
  const {
    contentParams: { helpId, selectedArray, footer, columns, helpTitle, getFieldValue },
    locale,
    randomKey
  } = (0, import_react.useContext)(import_functionalComponent.HelpContext);
  const {
    activeKey,
    setActiveKey,
    rightTable,
    getResult,
    tabBarExtraContent,
    advancedSearch,
    getTable,
    renderTreeList,
    changeCommonData
  } = (0, import_common.useCtx)(true);
  const btnRef = (0, import_react.useRef)();
  const renderTable = (0, import_util.useRefCallback)((index, listRequest) => {
    if (index === "treeStyle") {
      return renderTreeList();
    }
    return /* @__PURE__ */ import_react.default.createElement(
      import_functionalComponent.Table,
      {
        ...tableProps,
        style: { ...tableProps.style, borderTopWidth: 0 },
        id: `${helpId}_${randomKey}_${index}`,
        columns,
        pagination: {
          height: 32,
          showQuickJumper: false,
          align: "left"
        },
        onRow: (rowIndex, table) => ({
          onDoubleClick: () => btnRef.current.toRight([table.getRow(rowIndex)])
        }),
        request: listRequest
      }
    );
  });
  const items = (0, import_common.useTabItems)({ renderTable });
  return /* @__PURE__ */ import_react.default.createElement(import_util.Layout, null, /* @__PURE__ */ import_react.default.createElement(Header, { title: helpTitle || locale.multipleTitle }, tabBarExtraContent), advancedSearch, /* @__PURE__ */ import_react.default.createElement(import_util.Layout.Flex, { direction: "row", style: { padding: "0 5px" } }, /* @__PURE__ */ import_react.default.createElement(import_util.Layout.Flex, { flex: 2 }, /* @__PURE__ */ import_react.default.createElement(import_functionalComponent.Tabs, { className: "fit-height", size: "small", activeKey, onChange: setActiveKey, items })), /* @__PURE__ */ import_react.default.createElement(
    MultipleButtons,
    {
      getRowKey: getFieldValue,
      outRef: btnRef,
      getActiveTable: getTable,
      getResultTable: () => rightTable.current.getApi()
    }
  ), /* @__PURE__ */ import_react.default.createElement(import_util.Layout.Flex, { style: { paddingTop: 7 } }, /* @__PURE__ */ import_react.default.createElement(
    import_functionalComponent.Table,
    {
      ...tableProps,
      columns,
      dataSource: selectedArray,
      ref: rightTable,
      onRow: (rowIndex) => ({
        onDoubleClick: () => btnRef.current.toLeft(rowIndex)
      })
    }
  ))), /* @__PURE__ */ import_react.default.createElement(Footer, { getResult }, /* @__PURE__ */ import_react.default.createElement(import_functionalComponent.Button, { style: { marginLeft: 5 }, onClick: changeCommonData }, activeKey === "commonData" ? locale.DelCommonUse : locale.AddCommonUse), footer && /* @__PURE__ */ import_react.default.createElement("span", { children: footer })));
}
var MultipleHelp = (0, import_util.compHoc)((props) => {
  const [helpProps, modalProps] = (0, import_common.useHelp)(props);
  const { width, height } = (0, import_util.getGlobalConfig)().default.helpConfig;
  return /* @__PURE__ */ import_react.default.createElement(import_functionalComponent.BaseHelp, { ...helpProps, multiple: true, helpContent: HelpContent, modalProps: { width, height, ...modalProps } });
}, "MultipleHelp");
var MultipleHelpSelect = import_react.default.forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ import_react.default.createElement(MultipleHelp, { ...props, ref, modal: false });
  }
);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  MultipleHelp,
  MultipleHelpSelect
});
