var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/help/ProjectUserHelp.tsx
var ProjectUserHelp_exports = {};
__export(ProjectUserHelp_exports, {
  ProjectUserHelp: () => ProjectUserHelp
});
module.exports = __toCommonJS(ProjectUserHelp_exports);
var import_react = __toESM(require("react"));
var import_baseComponent = require("../../baseComponent");
var import_functionalComponent = require("../../functionalComponent");
var import_util = require("../../util");
var import_common = require("./common");
var { Option } = import_functionalComponent.Tabs;
var { Header, Footer, MultipleButtons } = import_functionalComponent.BaseHelp;
var tableProps = {
  rowSelected: false,
  rowChecked: true,
  cache: false,
  headerMenu: false,
  style: { borderStyle: "solid", borderColor: "var(--border-color-split, #f0f0f0)", borderWidth: 1 }
};
function HelpContent() {
  const {
    request,
    ok,
    contentParams: { getFieldValue, columns, helpTitle, helpId, selectedArray, multiple, footer, treeProps, projCode },
    locale,
    randomKey
  } = (0, import_react.useContext)(import_functionalComponent.HelpContext);
  const btnRef = (0, import_react.useRef)();
  const [activeKey, setActiveKey] = (0, import_react.useState)("0");
  const rightTable = (0, import_react.useRef)();
  const getTable = () => import_util.udp.compIns[`${helpId}_${randomKey}_${activeKey}`].getApi();
  (0, import_react.useEffect)(() => {
    getTable().setExtraParam({ projCode });
  }, []);
  const getResult = () => {
    if (multiple) {
      const result = rightTable.current.getApi().getRows().map((r) => ({
        value: getFieldValue(r),
        label: getFieldValue(r, "label"),
        origin: { ...r }
      }));
      return result.length > 0 ? result : void 0;
    } else {
      const value = getTable().getSelectedData()[0];
      if (value) {
        return { value: getFieldValue(value), label: getFieldValue(value, "label"), origin: { ...value } };
      }
      return void 0;
    }
  };
  const toRight = (values) => {
    if (multiple) {
      btnRef.current.toRight(values);
    } else {
      ok(getResult());
    }
  };
  const onSearch = (value) => {
    if (activeKey === "0") {
      getTable().query({ keyword: value });
    } else {
      getTable().filter(value);
    }
  };
  const tabTitle = (t) => /* @__PURE__ */ import_react.default.createElement("span", { style: { padding: "0 8px" } }, t);
  const tabBarExtraContent = /* @__PURE__ */ import_react.default.createElement(import_baseComponent.Search, { size: "small", allowClear: true, placeholder: locale.searchPlaceholder, onSearch });
  tableProps.checkbox = multiple ? "checked" : false;
  tableProps.rowSelected = !multiple;
  tableProps.rowChecked = multiple;
  const renderTable = (index) => {
    return /* @__PURE__ */ import_react.default.createElement(
      import_functionalComponent.Table,
      {
        ...tableProps,
        style: { ...tableProps.style, borderTopWidth: 0 },
        id: `${helpId}_${randomKey}_${index}`,
        columns,
        pagination: {
          height: 32,
          showQuickJumper: false,
          align: "left",
          targetContainer: multiple && index === 0 ? `${helpId}_${randomKey}_pagination` : ""
        },
        onRow: (rowIndex, table) => ({
          onDoubleClick: () => toRight([table.getRow(rowIndex)])
        }),
        autoLoad: treeProps.defaultSelectedFirstNode === false,
        request,
        response: (res) => ({ total: res.total ?? 0, record: res.list || [] })
      }
    );
  };
  const borderStyle = activeKey === "0" ? "1px solid var(--border-color-split, #f0f0f0)" : "1px solid transparent";
  return /* @__PURE__ */ import_react.default.createElement(import_util.Layout, null, /* @__PURE__ */ import_react.default.createElement(Header, { title: helpTitle || "项目人员帮助" }), /* @__PURE__ */ import_react.default.createElement(import_util.Layout.Flex, { direction: "row", style: { padding: "0 5px", borderBottom: multiple ? borderStyle : 0 } }, /* @__PURE__ */ import_react.default.createElement(import_util.Layout.Flex, { flex: 2 }, /* @__PURE__ */ import_react.default.createElement(import_functionalComponent.Tabs, { className: "fit-height", size: "small", onChange: setActiveKey, tabBarExtraContent }, /* @__PURE__ */ import_react.default.createElement(Option, { tab: tabTitle(locale.List), key: "0" }, /* @__PURE__ */ import_react.default.createElement(import_util.Layout, { direction: "row", style: { height: "100%" } }, /* @__PURE__ */ import_react.default.createElement(import_util.Layout.Flex, { style: { paddingBottom: multiple ? 32 : 0 } }, renderTable(0)))))), multiple && /* @__PURE__ */ import_react.default.createElement(
    MultipleButtons,
    {
      getRowKey: getFieldValue,
      outRef: btnRef,
      getActiveTable: getTable,
      getResultTable: () => rightTable.current.getApi()
    }
  ), multiple && /* @__PURE__ */ import_react.default.createElement(import_util.Layout.Flex, { style: { paddingTop: 7, paddingBottom: activeKey === "0" ? 32 : 0 } }, /* @__PURE__ */ import_react.default.createElement(
    import_functionalComponent.Table,
    {
      ...tableProps,
      columns,
      dataSource: selectedArray,
      ref: rightTable,
      onRow: (rowIndex) => ({
        onDoubleClick: () => btnRef.current.toLeft(rowIndex)
      })
    }
  ), /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      id: `${helpId}_${randomKey}_pagination`,
      style: {
        position: "absolute",
        left: activeKey === "1" ? 14 : 205,
        right: 15,
        borderLeft: borderStyle,
        paddingLeft: 10
      }
    }
  ))), /* @__PURE__ */ import_react.default.createElement(Footer, { getResult }, footer && /* @__PURE__ */ import_react.default.createElement("span", { style: { flex: 1, width: 0 }, children: footer })));
}
var ProjectUserHelp = (0, import_util.compHoc)((props) => {
  const cacheHelpInfo = (0, import_react.useRef)({ data: null, p: null });
  const {
    valueField = "userNo",
    labelField = "userName",
    displayField,
    userCodeField,
    title,
    multiple = false,
    modalProps,
    footer,
    params: treeParams,
    treeRequest,
    beforeRequest: beforeTreeRequest,
    projectRequest,
    projectParams = {},
    columns,
    onBeforeOpen,
    treeProps,
    ...others
  } = props;
  const helpId = "projectPositions";
  const otherProps = others;
  otherProps.onBeforeOpen = (0, import_util.useRefCallback)(async () => {
    const [status, helpInfo] = await (0, import_common.getHelpBeforeOpen)({ onBeforeOpen, cacheHelpInfo });
    if (import_util.udp.isObject(helpInfo)) {
      return helpInfo;
    }
    return status;
  });
  otherProps.request = (0, import_util.useRefCallback)(async ({ pageIndex, pageSize, keyword = "", projCode }) => {
    const data = {
      ...projectParams,
      pageNum: pageIndex,
      pageSize,
      orders: [
        {
          property: "",
          direction: ""
        }
      ],
      searchStr: keyword.trim(),
      projCode
    };
    if (projectRequest) {
      return await projectRequest(data);
    }
    const res = await import_util.udp.request.body({
      url: "/basedata/postuser/searchByUser",
      data
    });
    if ((res == null ? void 0 : res.code) === 0)
      return res == null ? void 0 : res.data;
    return { list: [], total: 0 };
  });
  otherProps.valueField = valueField;
  otherProps.userCodeField = userCodeField;
  otherProps.labelField = labelField || displayField;
  otherProps.contentParams = {
    footer,
    helpId,
    multiple,
    valueField,
    labelField: otherProps.labelField,
    treeProps: {
      params: treeParams,
      beforeRequest: beforeTreeRequest,
      treeRequest,
      ...treeProps
    },
    columns: columns ?? [
      { dataIndex: "userNo", title: "人员编码", width: multiple ? 150 : 180 },
      { dataIndex: "userName", title: "姓名", tooltip: true },
      { dataIndex: "orgName", title: "所属组织", tooltip: true },
      { dataIndex: "projectName", title: "项目", tooltip: true },
      { dataIndex: "postNameStr", title: "岗位", tooltip: true },
      { dataIndex: "roleNameStr", title: "项目角色", tooltip: true }
    ]
  };
  if (title) {
    otherProps.contentParams.helpTitle = title;
  }
  if (onBeforeOpen) {
    otherProps.cache = false;
  }
  otherProps.selectedRequest = (0, import_util.useRefCallback)(async ({ codes }) => {
    try {
      const { code, data } = await import_util.udp.request.body({
        url: "/basedata/postuser/selectByProjcodeAndUserNo",
        skipError: true,
        data: {
          userNo: codes.split(","),
          projCode: otherProps.projCode
        }
      });
      return code === 0 ? data : [];
    } catch (e) {
    }
    return [];
  });
  const { height, width } = (0, import_util.getGlobalConfig)().default.helpConfig;
  return /* @__PURE__ */ import_react.default.createElement(
    import_functionalComponent.BaseHelp,
    {
      ...otherProps,
      modal: true,
      helpContent: HelpContent,
      multiple,
      modalProps: { width, height, ...modalProps }
    }
  );
}, "ProjectUserHelp");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ProjectUserHelp
});
