var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/help/UserHelp/index.tsx
var UserHelp_exports = {};
__export(UserHelp_exports, {
  UserHelp: () => UserHelp
});
module.exports = __toCommonJS(UserHelp_exports);
var import_react = require("react");
var import_baseComponent = require("../../../baseComponent");
var import_functionalComponent = require("../../../functionalComponent");
var import_util = require("../../../util");
var import_common = require("../common");
var import_UserCompanyHelp = __toESM(require("./UserCompanyHelp"));
var import_UserProjectHelp = __toESM(require("./UserProjectHelp"));
var import_utils = require("./utils");
var { Option } = import_functionalComponent.Tabs;
var { Header, Footer, MultipleButtons } = import_functionalComponent.BaseHelp;
var tableProps = {
  rowSelected: false,
  rowChecked: true,
  cache: false,
  headerMenu: false,
  style: { borderStyle: "solid", borderColor: "var(--border-color-split, #f0f0f0)", borderWidth: 1 }
};
function HelpContent() {
  const {
    request,
    ok,
    contentParams: {
      showTree = true,
      getFieldValue,
      columns,
      helpTitle,
      helpId,
      selectedArray,
      multiple,
      footer,
      treeProps,
      isProject
    },
    locale,
    randomKey
  } = (0, import_react.useContext)(import_functionalComponent.HelpContext);
  const btnRef = (0, import_react.useRef)();
  const [activeKey, setActiveKey] = (0, import_react.useState)(isProject ? "0" : "1");
  const [flag, setFlag] = (0, import_react.useState)(false);
  const rightTable = (0, import_react.useRef)();
  const borderStyle = activeKey === "0" ? "1px solid var(--border-color-split, #f0f0f0)" : "1px solid transparent";
  const getTable = (0, import_react.useCallback)(() => import_util.udp.compIns[`${helpId}_${randomKey}_${activeKey}`].getApi(), [activeKey]);
  const getResult = () => {
    if (multiple) {
      const result = rightTable.current.getApi().getRows().map((r) => ({
        value: getFieldValue(r),
        label: getFieldValue(r, "label"),
        origin: { ...r, activeKey }
      }));
      return result.length > 0 ? result : void 0;
    } else {
      const value = getTable().getSelectedData()[0];
      if (value) {
        return { value: getFieldValue(value), label: getFieldValue(value, "label"), origin: { ...value, activeKey } };
      }
      return void 0;
    }
  };
  const toRight = (values) => {
    if (multiple) {
      btnRef.current.toRight(values);
    } else {
      ok(getResult());
    }
  };
  const onSearch = (value) => {
    if (["0", "1"].includes(activeKey)) {
      getTable().query({ keyword: value });
    } else {
      getTable().filter(value);
    }
  };
  const tabBarExtraContent = /* @__PURE__ */ React.createElement(import_baseComponent.Search, { size: "small", allowClear: true, placeholder: locale.searchPlaceholder, onSearch });
  tableProps.checkbox = multiple ? "checked" : false;
  tableProps.rowSelected = !multiple;
  tableProps.rowChecked = multiple;
  const onDataLoad = (0, import_util.useRefCallback)((table) => {
    const { dataSource = [] } = table.getState() || {};
    const selectIndex = (0, import_utils.findFilterIndexes)(dataSource, (it) => (selectedArray || []).map((x) => x.id).includes(it.id));
    table.setSelected(selectIndex);
  });
  const renderTable = (index) => {
    return /* @__PURE__ */ React.createElement(
      import_functionalComponent.Table,
      {
        ...tableProps,
        style: { ...tableProps.style, borderTopWidth: 0 },
        id: `${helpId}_${randomKey}_${index}`,
        columns,
        pagination: {
          height: 32,
          showQuickJumper: false,
          align: "left",
          targetContainer: multiple ? `${helpId}_${randomKey}_pagination` : ""
        },
        onRow: (rowIndex, table) => ({
          onDoubleClick: () => toRight([table.getRow(rowIndex)])
        }),
        autoLoad: !index && activeKey === "0" && !flag,
        request: (params) => request(Object.assign({}, params, { isProjectHelp: activeKey === "0" })),
        response: (res) => ({ total: res.total ?? 0, record: res.list || [] }),
        onDataLoad
      }
    );
  };
  return /* @__PURE__ */ React.createElement(import_util.Layout, null, /* @__PURE__ */ React.createElement(Header, { title: helpTitle || "用户帮助" }), /* @__PURE__ */ React.createElement(import_util.Layout.Flex, { direction: "row", style: { padding: "0 5px", borderBottom: multiple ? borderStyle : 0 } }, /* @__PURE__ */ React.createElement(import_util.Layout.Flex, { flex: 2 }, /* @__PURE__ */ React.createElement(
    import_functionalComponent.Tabs,
    {
      className: "fit-height",
      size: "small",
      onChange: (key) => {
        setActiveKey(key);
        setFlag(true);
      },
      tabBarExtraContent,
      activeKey
    },
    isProject && /* @__PURE__ */ React.createElement(Option, { tab: /* @__PURE__ */ React.createElement("span", { style: { padding: "0 8px" } }, "项目"), key: "0" }, /* @__PURE__ */ React.createElement(import_UserProjectHelp.default, { renderTable, multiple })),
    /* @__PURE__ */ React.createElement(Option, { tab: /* @__PURE__ */ React.createElement("span", { style: { padding: "0 8px" } }, "公司"), key: "1" }, /* @__PURE__ */ React.createElement(
      import_UserCompanyHelp.default,
      {
        borderStyle,
        treeProps,
        renderTable,
        getTable,
        multiple,
        showTree
      }
    ))
  )), multiple && /* @__PURE__ */ React.createElement(
    MultipleButtons,
    {
      getRowKey: getFieldValue,
      outRef: btnRef,
      getActiveTable: getTable,
      getResultTable: () => rightTable.current.getApi()
    }
  ), multiple && /* @__PURE__ */ React.createElement(import_util.Layout.Flex, { style: { paddingTop: 7, paddingBottom: ["0", "1"].includes(activeKey) ? 32 : 0 } }, /* @__PURE__ */ React.createElement(
    import_functionalComponent.Table,
    {
      ...tableProps,
      columns,
      dataSource: selectedArray,
      ref: rightTable,
      onRow: (rowIndex) => ({
        onDoubleClick: () => btnRef.current.toLeft(rowIndex)
      })
    }
  ), /* @__PURE__ */ React.createElement(
    "div",
    {
      id: `${helpId}_${randomKey}_pagination`,
      style: {
        position: "absolute",
        left: activeKey === "0" ? 5 : 205,
        right: 15,
        borderLeft: borderStyle,
        paddingLeft: 10
      }
    }
  ))), /* @__PURE__ */ React.createElement(Footer, { getResult }, footer && /* @__PURE__ */ React.createElement("span", { style: { flex: 1, width: 0 }, children: footer })));
}
var UserHelp = (0, import_util.compHoc)((props) => {
  const cacheHelpInfo = (0, import_react.useRef)({ data: null, p: null });
  const {
    valueField = "userNo",
    labelField = "userName",
    isProject = false,
    showTree = true,
    displayField,
    userCodeField,
    title,
    multiple = false,
    modalProps,
    footer,
    params: treeParams,
    treeRequest,
    beforeRequest: beforeTreeRequest,
    userRequest,
    userParams = {},
    columns,
    onBeforeOpen,
    ...others
  } = props;
  const helpId = "user";
  const otherProps = others;
  otherProps.onBeforeOpen = (0, import_util.useRefCallback)(async () => {
    const [status, helpInfo] = await (0, import_common.getHelpBeforeOpen)({ onBeforeOpen, cacheHelpInfo });
    if (import_util.udp.isObject(helpInfo)) {
      return helpInfo;
    }
    return status;
  });
  otherProps.request = (0, import_util.useRefCallback)(
    async ({ pageIndex, pageSize, keyword, treeNodes, containLowOrgUser = false, isProjectHelp }) => {
      const data = {
        ...userParams,
        containLowOrgUser,
        pageNum: pageIndex,
        pageSize
      };
      isProjectHelp && (data.projType = true);
      keyword && (data.query = keyword);
      if (treeNodes && treeNodes.length > 0) {
        const { code, leafType } = treeNodes[0];
        const keys = { PROJECT: "belongProject", DEPT: "belongDept", ORG: "belongOrg" };
        if (!data[keys[leafType]]) {
          data[keys[leafType]] = code;
        }
      }
      if (userRequest) {
        return await userRequest(data);
      }
      const res = await import_util.udp.request.body({
        url: "/basedata/user/getUserPages",
        data
      });
      if ((res == null ? void 0 : res.code) === 0)
        return res == null ? void 0 : res.data;
      return { list: [], total: 0 };
    }
  );
  otherProps.valueField = valueField;
  otherProps.userCodeField = userCodeField;
  otherProps.labelField = labelField || displayField;
  otherProps.contentParams = {
    footer,
    helpId,
    showTree,
    multiple,
    valueField,
    labelField: otherProps.labelField,
    treeProps: {
      params: treeParams,
      beforeRequest: beforeTreeRequest,
      treeRequest
    },
    columns: columns ?? [
      { dataIndex: "userNo", title: "用户编号" },
      { dataIndex: "userName", title: "用户名称" },
      { dataIndex: "belongOrgName", title: "所属组织" },
      {
        dataIndex: "userJobList",
        tooltip: "render",
        title: "所属部门",
        render({ value }) {
          return /* @__PURE__ */ React.createElement("span", { className: "nowrap" }, value == null ? void 0 : value.map((v) => v.deptName).join(","));
        }
      },
      {
        dataIndex: "projectPost",
        title: "岗位"
      }
    ],
    isProject
  };
  if (title) {
    otherProps.contentParams.helpTitle = title;
  }
  if (onBeforeOpen) {
    otherProps.cache = false;
  }
  const { width, height } = (0, import_util.getGlobalConfig)().default.helpConfig;
  return /* @__PURE__ */ React.createElement(
    import_functionalComponent.BaseHelp,
    {
      ...otherProps,
      modal: true,
      helpContent: HelpContent,
      multiple,
      modalProps: { width, height, ...modalProps }
    }
  );
}, "UserHelp");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  UserHelp
});
