import React, { ReactNode } from 'react';
import { type IObject } from '../../util';
export interface IHelpExtraProps {
    /**
     * @description       通用帮助标记id
     */
    helpId: string | Function;
    /**
     * @description       数据列表的过滤条件
     */
    clientSqlFilter?: string | IObject | Function;
    /**
     * @description       业务需要，暂时不知道什么意思
     */
    infoRightUIContainerID?: string;
    /**
     * @description       底部扩展组件
     */
    footer?: React.ReactNode;
    showList?: boolean;
    /**
     * @description       多选时是否支持上下联动，默认联动
     * @default           false
     */
    checkStrictly?: boolean;
    /**
     * @description       树形帮助不可选的层级，0表示所有层级可选（仅树形帮助有效），
     * @default           0
     */
    treeDisabledLevel?: number;
    /**
     * @description       树形只支持末级选中（仅树形帮助有效），
     * @default           false
     */
    onlySelectedFinally?: boolean;
}
export declare function useHelp(props: any): any[];
export declare function useTabKey(initTabs?: () => string[]): any[];
export declare function useCtx(multiple: boolean): {
    activeKey: any;
    setActiveKey: any;
    tabBarExtraContent: import("react/jsx-runtime").JSX.Element;
    advancedSearch: import("react/jsx-runtime").JSX.Element | null;
    rightTable: React.MutableRefObject<any>;
    getTable: () => any;
    renderTreeList: () => import("react/jsx-runtime").JSX.Element;
    changeCommonData: () => Promise<void>;
    getResult: any;
};
export declare function useTabItems({ renderTable }: {
    renderTable: any;
}): {
    key: string;
    label: ReactNode;
    children: ReactNode;
}[];
export declare function getHelpBeforeOpen({ helpId, onBeforeOpen, cacheHelpInfo }: {
    helpId?: string | undefined;
    onBeforeOpen: any;
    cacheHelpInfo: any;
}, props?: any): Promise<any[]>;
