/**
 * 保存上一次激活的tab页
 * @param helpId
 * @param activeTabKey
 */
export declare function saveActiveTabKey({ helpId, activeTabKey }: {
    helpId: any;
    activeTabKey: any;
}): Promise<void>;
/**
 * 获取上一次激活的tab页
 */
export declare function getActiveTabKey({ helpId }: {
    helpId: any;
}): Promise<undefined>;
/**
 * 获取通用帮助基本信息
 * @param helpId 帮助标识
 */
export declare function getHelpInfo({ helpId }: {
    helpId: any;
}): Promise<any>;
/**
 * 获取通用帮助列表数据
 * @param helpId 通用帮助标识
 * @param keyword 查询关键字
 * @param pageIndex 分页索引
 * @param pageSize 每页最大显示数
 * @param clientSqlFilter 过滤条件
 * @param infoRightUIContainerID 容器ID
 */
export declare function getHelpList({ helpId, keyword, pageIndex, pageSize, clientSqlFilter, infoRightUIContainerID }: {
    helpId: any;
    keyword?: string | undefined;
    pageIndex: any;
    pageSize: any;
    clientSqlFilter: any;
    infoRightUIContainerID: any;
}): Promise<any>;
/**
 * 获取通用帮助树数据
 * @param param
 * @returns
 */
export declare function getTreeList({ helpId, clientSqlFilter }: {
    helpId: any;
    clientSqlFilter: any;
}): Promise<any>;
/**
 * 获取已选择的数据
 * @returns
 */
export declare function getSelectedData({ helpId, codes }: {
    helpId: any;
    codes: any;
}): Promise<any>;
/**
 * 获取通用帮助常用列表
 * @param helpId 通用帮助标识
 * @param pageIndex
 * @param pageSize
 * @param clientSqlFilter
 * @param infoRightUIContainerID
 */
export declare function getCommonList({ helpId, pageIndex, pageSize, clientSqlFilter, infoRightUIContainerID }: {
    helpId: any;
    pageIndex: any;
    pageSize: any;
    clientSqlFilter: any;
    infoRightUIContainerID: any;
}): Promise<any>;
/**
 * 添加常用数据
 * @param helpId 通用帮助标识
 * @param codeValue 常用数据主键
 */
export declare function addCommonData({ helpId, codeValue }: {
    helpId: any;
    codeValue: any;
}): Promise<any>;
/**
 * 移除常用数据
 * @param helpId 通用帮助标识
 * @param codeValue 常用数据主键
 */
export declare function deleteCommonData({ helpId, codeValue }: {
    helpId: any;
    codeValue: any;
}): Promise<any>;
/**
 * 获取通用帮助最近使用列表
 * @param helpId 通用帮助标识
 * @param pageIndex
 * @param pageSize
 * @param clientSqlFilter
 * @param infoRightUIContainerID
 */
export declare function getRecentlyList({ helpId, pageIndex, pageSize, clientSqlFilter, infoRightUIContainerID }: {
    helpId: any;
    pageIndex: any;
    pageSize: any;
    clientSqlFilter: any;
    infoRightUIContainerID: any;
}): Promise<{
    record: never[];
    total: number;
}>;
/**
 * 添加最近数据
 * @param helpId 通用帮助标识
 * @param codeValue 最近数据主键
 */
export declare function addRecentlyData({ helpId, codeValue }: {
    helpId: any;
    codeValue: any;
}): Promise<boolean>;
