var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/imp/cpts/components/TreeTable.tsx
var TreeTable_exports = {};
__export(TreeTable_exports, {
  default: () => TreeTable_default
});
module.exports = __toCommonJS(TreeTable_exports);
var import_react = require("react");
var import_functionalComponent = require("../../../../functionalComponent");
var import_util = require("../../../../util");
var import_org_tree = require("../../../org-tree");
var import_query_panel = require("../../../query-panel");
var import_service = require("../../service");
var import_utils = require("../../utils");
var import_NoticeIconContent = __toESM(require("./NoticeIconContent"));
var TreeTable = (props) => {
  var _a;
  const {
    getRef,
    state,
    popupMode,
    flowCode,
    busData,
    dependentState,
    changeDependent,
    rowDisable,
    iconVisible,
    onDataLoad
  } = props;
  const tableRequest = (0, import_react.useCallback)(
    (defaultParams) => {
      if (!dependentState) {
        return Promise.resolve({ total: 0, list: [] });
      }
      const sourceId = state.sourceId;
      const newsourceId = (sourceId == null ? void 0 : sourceId.indexOf("_")) ? import_util.udp.split(sourceId, "_")[1] : sourceId;
      return (0, import_service.loadSourceData)({
        flowCode,
        busData,
        ...defaultParams,
        popupMode,
        sourceId: newsourceId,
        treeFilterValue: dependentState
      });
    },
    [dependentState]
  );
  const treeRequest = (0, import_react.useCallback)(() => {
    return (0, import_service.getTreeList)(state == null ? void 0 : state.treeFieldConfig);
  }, [JSON.stringify(state.treeFieldConfig)]);
  const onSearch = (_, queryCondition) => {
    var _a2, _b;
    (_b = (_a2 = getRef("table")) == null ? void 0 : _a2.current) == null ? void 0 : _b.getApi().setExtraParam({ queryCondition });
  };
  const onSelectedChange = (_, record) => {
    const selectIds = (0, import_utils.loopTreeChildren)(record) || [];
    changeDependent(selectIds.join(","));
  };
  return /* @__PURE__ */ React.createElement(import_util.Layout.Flex, { direction: "row", style: { height: "100%" } }, /* @__PURE__ */ React.createElement(import_util.Layout.Slider, { size: 200, style: { marginRight: "var(--inner-margin, 16px)", borderRight: import_util.cssVar.border } }, /* @__PURE__ */ React.createElement(import_functionalComponent.Panel, { title: ((_a = state == null ? void 0 : state.treeFieldConfig) == null ? void 0 : _a.title) || "树", autoFit: true }), /* @__PURE__ */ React.createElement(import_org_tree.OrgTree, { onSelectedChange, treeRequest })), /* @__PURE__ */ React.createElement(import_util.Layout.Flex, { direction: "column" }, state.queryItems.length > 0 && /* @__PURE__ */ React.createElement(import_query_panel.QueryPanel, { items: state.queryItems, onSearch }), /* @__PURE__ */ React.createElement(import_NoticeIconContent.default, { iconVisible }, /* @__PURE__ */ React.createElement(
    import_functionalComponent.Table,
    {
      showRowNumber: true,
      columns: state.columns,
      ref: getRef("table"),
      autoLoad: true,
      request: tableRequest,
      key: state.sourceId,
      pagination: { hideOnSinglePage: false },
      rowSelection: {
        type: state.allowMultiSelect == 1 ? [import_functionalComponent.TableSelectionModel.MULTIPLE_INTERVAL, import_functionalComponent.TableSelectionModel.CHECKBOX] : import_functionalComponent.TableSelectionModel.ROW,
        disabled: rowDisable
      },
      onDataLoad
    }
  ))));
};
var TreeTable_default = (0, import_react.memo)(TreeTable);
