/**
 * 根据业务类型获取可用的业务流列表
 */
export declare function getFlowList({ bizCode, orgId, tenantId, bizType, contractTypes }: {
    bizCode: any;
    orgId: any;
    tenantId: any;
    bizType: any;
    contractTypes: any;
}): Promise<any>;
/**
 * 获取来源树
 */
export declare function loadSourceTree({ bizCode, tableName, flowCode, sourceBizCode }: {
    bizCode: any;
    tableName: any;
    flowCode: any;
    sourceBizCode: any;
}): Promise<any[]>;
/**
 * 获取来源的配置信息
 * @param sourceId 来源id
 */
export declare function loadSourceConfig({ sourceId }: {
    sourceId: any;
}): Promise<any>;
/**
 * 获取来源的数据信息
 */
export declare function loadSourceData({ sourceId, pageIndex, pageSize, queryCondition, flowCode, busData, popupMode, masterId, treeFilterValue }: any): Promise<any>;
/**
 * 转换来源数据
 */
export declare function converSourceData({ sourceId, flowCode, sourceDatas, detailTables, mainRuleHelpInfo }: {
    sourceId: any;
    flowCode: any;
    sourceDatas: any;
    detailTables: any;
    mainRuleHelpInfo: any;
}): Promise<any[]>;
/**
 * 获取通用帮助树数据
 * @param param
 * @returns
 */
export declare function getTreeList({ helpId, clientSqlFilter }: {
    helpId: any;
    clientSqlFilter: any;
}): Promise<any>;
/**
 * 来源帮助-已选择
 */
export declare function getSeletcedList(params: any): Promise<any>;
/**
 * 检测是否生成待办任务
 * @params
 * @flowCode string
 * @returns  { "generateTask": true, "needUser": true }// 是否需要生成代办任务，需要user用户帮助
}}
 */
export declare function checkGenerateTask(params: {
    flowCode: string;
    bizCode: string;
    instanceId?: string;
    bizId?: string;
}): Promise<{
    generateTask: boolean;
    needUser: boolean;
}>;
/**
 * 生成代办任务
 */
export declare function autoGenerateTask(params: {
    flowCode: string;
    bizCode: string;
    bizId: string;
    userNos?: string[];
}): Promise<boolean>;
