/// <reference types="react" />
import { FormInstance } from 'antd/es/form';
import { type ICurrentObject } from '../../util';
import './index.less';
import type { IQueryPanelProps } from './interface';
declare const defaultLocale: {
    title: string;
    search: string;
    reset: string;
    up: string;
    down: string;
    rememberCheckbox: string;
    settingTitle: string;
    settingCondition: string;
    settingScheme: string;
    resetText: string;
    okText: string;
    cancelText: string;
    settingText: string;
    queryScheme: string;
    confirmText: string;
};
type LocaleType = typeof defaultLocale;
type LocaleKeys = keyof LocaleType;
export type IQueryPanelPropsType = IQueryPanelProps<LocaleKeys>;
export interface IQueryInstance extends FormInstance {
    getSearchValues: () => any;
    getItem: (name: string) => any;
    setFieldValue: (name: any, value: any) => void;
    query: () => void;
    getQueryInfo: () => void;
}
/**
 * 内嵌查询控件
 * @param props
 * @constructor
 */
export declare const QueryPanel: import("react").ForwardRefExoticComponent<IQueryPanelPropsType & import("react").RefAttributes<ICurrentObject<IQueryInstance>>>;
export {};
