/**
 * 获取查询控件信息
 * @param pageId 业务标识
 */
export declare function getQueryPanelInfo({ pageId }: {
    pageId: any;
}): Promise<any>;
/**
 * 保存查询记忆
 * @param pageId 业务标识
 * @param values 查询控件记忆条件
 * @param checked 为false时，自动清空记忆条件
 */
export declare function setQueryPanelData({ pageId, values, checked }: {
    pageId: any;
    values: any;
    checked: any;
}): Promise<any>;
/**
 * 获取查询控件设置信息
 * @param pageId 业务标识
 */
export declare function getQuerySettingInfo({ pageId }: {
    pageId: any;
}): Promise<any>;
/**
 * 保存设置信息
 * @param pageId 业务标识
 * @param data
 */
export declare function saveQuerySettingInfo({ pageId, data }: {
    pageId: any;
    data: any;
}): Promise<any>;
/**
 * 重置查询设置
 * @param pageId 业务标识
 */
export declare function resetQuerySettingInfo({ pageId }: {
    pageId: any;
}): any;
/**
 * 获取查询方案
 * @param pageId 业务标识
 */
export declare function getQueryScheme({ pageId }: {
    pageId: any;
}): Promise<never[]>;
/**
 * 获取查询方案的详细信息
 * @param schemeId 方案id
 */
export declare function getQuerySchemeDetail({ schemeId }: {
    schemeId: any;
}): Promise<import("@cscec/udp-core/src/interface/types/IRequestOptions").IResponse>;
/**
 * 获取方案树
 * @param pageId 业务标识
 */
export declare function getQuerySchemeTree({ pageId }: {
    pageId: any;
}): Promise<any>;
/**
 * 获取方案对应的查询条件
 * @param schemeId 方案id
 */
export declare function getQuerySchemeData({ schemeId }: {
    schemeId: any;
}): Promise<any>;
/**
 * 新增查询方案
 * @param schemeName 方案名称
 * @param pageId 业务标识
 */
export declare function addQueryScheme({ schemeName, pageId }: {
    schemeName: any;
    pageId: any;
}): Promise<boolean>;
/**
 * 删除查询方案
 * @param schemeId 方案id
 */
export declare function deleteQueryScheme({ schemeId }: {
    schemeId: any;
}): Promise<boolean>;
/**
 * 更新查询方案状态
 * @param schemeId 方案id
 * @param status 状态： 0 停用 1 启用
 */
export declare function updateQuerySchemeStatus({ schemeId, status }: {
    schemeId: any;
    status: any;
}): Promise<boolean>;
/**
 * 保存方案详情
 * @param schemeId 方案id
 * @param data 详情信息
 */
export declare function saveQuerySchemeData({ schemeId, data }: {
    schemeId: any;
    data: any;
}): Promise<boolean>;
