/// <reference types="react" />
import { IAsyncTreeProps } from '../../functionalComponent';
declare const defaultProps: {
    orgattr: string;
    isLazyLoad: boolean;
    isIncludeDept: boolean;
    isRight: boolean;
    isActive: boolean;
    isDeptRight: boolean;
    sqlName: string;
    selectedorgid: string;
    orglabel: string;
    isFromWM: string;
    isZhinengDept: boolean;
};
export type OrgTreeParamType = Partial<typeof defaultProps> & {
    clientSqlFilter?: string | Function;
};
export type OrgTreeType = Omit<IAsyncTreeProps, 'request'> & {
    titleField?: string;
    defaultSelectedFirstNode?: boolean;
    params?: OrgTreeParamType;
    beforeRequest?: (...args: any[]) => Promise<boolean | void>;
};
/**
 * 导出组织树控件， 默认不懒加载 包括部门 无权限 过滤休眠
 */
export declare const WFOrgtree: import("react").ForwardRefExoticComponent<Omit<Omit<IAsyncTreeProps, "request"> & {
    titleField?: string | undefined;
    defaultSelectedFirstNode?: boolean | undefined;
    params?: OrgTreeParamType | undefined;
    beforeRequest?: ((...args: any[]) => Promise<boolean | void>) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export {};
