import { showFlowInfo, showFlowInfoByPiId } from './util';
/**
 * 工作流api
 */
declare const $WorkFlow: {
    startFlow(params: {
        appCode?: string;
        bizCode: string;
        dataId: string;
        cuNo?: string;
        orgNo?: string;
        processType?: string;
        formApprovalUserNo?: string;
        successCallback?: Function;
        cancelCallback?: Function;
    }): Promise<unknown>;
    batchStartFlow(params: {
        bizCode: string;
        bacthFlowList: any;
        successCallback?: Function;
        cancelCallback?: Function;
    }): Promise<unknown>;
    startFlowWithNavigation({ bizType, bizPhId, busType, successCallback, cancelCallback, processType, formApprovalUserNo }: {
        bizType: any;
        bizPhId: any;
        busType: any;
        successCallback: any;
        cancelCallback: any;
        processType: any;
        formApprovalUserNo: any;
    }): Promise<void>;
    showFlowInfo: typeof showFlowInfo;
    showFlowInfoByPiId: typeof showFlowInfoByPiId;
    startFlowWithPdId(params: {
        appCode?: string;
        bizCode: string;
        dataId: string;
        pdId?: string;
        cuNo?: string;
        orgNo?: string;
        successCallback?: Function;
        cancelCallback?: Function;
    }): Promise<unknown>;
};
export { default as WorkFlowPanel } from './WorkFlowPanel';
export { $WorkFlow };
export type WorkFlowApiType = typeof $WorkFlow;
