import { message as AntMessage } from 'antd';
import type { NotificationInstance } from 'antd/es/notification/interface';
declare type voidFn = () => void;
interface IProgress {
    title?: string;
    animation?: boolean;
    afterClose?: voidFn;
    duration?: number;
    autoClose?: boolean;
}
type AntMessageType = typeof AntMessage;
type MessageApi = AntMessageType & {
    progress: (options?: IProgress) => voidFn;
    warn: AntMessageType['warning'];
};
export declare const message: MessageApi;
/**
 * 使用进度条
 * @param asyncFn
 * @param options
 */
export declare function usingProgress(asyncFn: Function, options?: IProgress): Promise<any>;
export declare const notification: NotificationInstance;
export {};
