import React from 'react';
import { Observer } from '../../util';
import { type ColumnProps } from '../table';
import type { IBaseHelpQuery, IFooter } from './interface';
import { helpLocale } from './locale';
export declare const HelpContext: React.Context<{
    observer: Observer;
    ok: (result?: any) => void;
    close: () => void;
    request: (query: IBaseHelpQuery) => Promise<any> | any;
    contentParams: {
        [key: string]: any;
        helpTitle?: string | undefined;
        FilterTree?: (({ onSelectedChange, tableRef }: {
            onSelectedChange: any;
            tableRef: any;
        }) => React.ReactNode) | undefined;
        columns: Array<ColumnProps> | {
            left: Array<ColumnProps>;
            right: Array<ColumnProps>;
        };
        getFieldValue: (row: any, type?: any) => any;
    };
    locale: typeof helpLocale;
    randomKey: string;
}>;
/**
 * 帮助头部区域
 * @param props
 * @constructor
 */
export declare function Header(props: any): import("react/jsx-runtime").JSX.Element;
/**
 * 帮助底部区域
 * @constructor
 * @param props
 */
export declare function Footer(props: IFooter): import("react/jsx-runtime").JSX.Element;
/**
 * 多选按钮
 * @param props
 * @constructor
 */
export declare function MultipleButtons(props: any): import("react/jsx-runtime").JSX.Element;
/**
 * 基础帮助content区域
 * @constructor
 */
export declare function BaseContent(): import("react/jsx-runtime").JSX.Element;
