import { emptyFn, getGlobalConfig, Observer, udp, ValueTypeEnum, type ICurrentObject, type IObject, type PromiseType } from '../../util';
export { compHoc, cssVar, getRegisterComponentWithProps, Layout, UdpComponent, useApi, useAsyncEffect, useDebounce, useDevState, useDraggableSort, useRefCallback, useRefState, useResize, useReturnCallback, useThrottle, useUdpEffect, useUpdateEffect } from '../../util';
export { emptyFn, udp as util, getGlobalConfig, Observer, ValueTypeEnum };
export type { ICurrentObject, IObject, PromiseType };
export declare function getScrollBarInfo(): {
    width: number;
    height: number;
};
export declare function getColumnHeader(column: any): any;
export declare function convertStyle(style?: any): any;
export declare function displayText(text: any): any;
export declare function domContains(parentClass: any, target: any): boolean;
export declare function dataSortOrder(data: any, orders: any[], dataIndexMap: any): any;
export declare function filterSymbol(obj: any): any;
export declare function stopPropagation(e: any): void;
/**
 * 获取format生成的render函数
 * @param format 数据格式化描述信息
 * @param render 单元格的渲染函数（兼容服务端返回的是函数字符串）
 * @param editor 编辑器
 * @param encrypted 是否加密
 */
export declare function getRender({ format, editor, render, encrypted }: {
    format: any;
    editor?: any;
    render?: string;
    encrypted?: boolean;
}): any;
/**
 * 前端列筛选函数
 * @param columnFilters
 * @param dataIndexMap
 * @param allMatch 是否所有列全匹配
 */
export declare function clientColumnFilter(columnFilters: any, dataIndexMap: any, allMatch?: boolean): (row: any) => boolean;
export declare function syncDefaultProps(props: any): any;
export declare function getCellInfoByEvent(): {
    dataIndex?: string | undefined;
    rowIndex: number;
};
/**
 * 获取显示列
 */
export declare function getDisplayField({ editor, dataIndex, row }: {
    editor: any;
    dataIndex: any;
    row: any;
}): any;
