import { IObject, PromiseType } from '@cscec/udp-core';
import { IUser } from './interface';
export declare const CommonUtil: {
    /**
     * 在列表页面注册回刷事件
     * @param busType 业务类型
     * @param callback 回刷事件
     */
    onRefreshList(busType: string, callback: Function): () => void;
    /**
     * 在编辑页面回刷列表页面
     * @param busType 业务类型
     * @param data 回刷数据值
     */
    refreshList(busType: string, data?: any): void;
    /**
     * 获取public文件夹下的路径，微前端下会自动拼接微前端地址
     * @param url
     */
    getPublicPath(url: string): string;
    /**
     *
     * @param path
     * @param queryParmas  microAppName 微应用名
     * @returns
     */
    open(path: string, queryParmas?: IObject & {
        microAppName?: string;
        AppTitle?: string;
    }): boolean;
    close(check?: boolean | IObject): Promise<boolean>;
    getUser<T = IUser>(): T;
    safeRefresh(query?: IObject): void;
    updateTitle(title: string): void;
    openHelp(params: {
        [x: string]: any;
        type: string;
        multiple?: boolean | undefined;
        helpId?: string | undefined;
    }): PromiseType<null | IObject | IObject[]>;
};
