import { type IObject, type IRegisterComponentOptions } from '@cscec/udp-core';
import React from 'react';
export * from '@cscec/udp-core';
export declare const udp: {
    registerExternal(obj: IObject): void;
    onRefreshList(busType: string, callback: Function): () => void;
    refreshList(busType: string, data?: any): void;
    getPublicPath(url: string): string;
    open(path: string, queryParmas?: IObject & {
        microAppName?: string | undefined;
        AppTitle?: string | undefined;
    }): boolean;
    close(check?: boolean | IObject): Promise<boolean>;
    getUser<T = import("./interface").IUser>(): T;
    safeRefresh(query?: IObject): void;
    updateTitle(title: string): void;
    openHelp(params: {
        [x: string]: any;
        type: string;
        multiple?: boolean | undefined;
        helpId?: string | undefined;
    }): import("@cscec/udp-core").PromiseType<IObject | IObject[] | null>;
    getHistory: typeof import("@cscec/udp-core").getHistory;
    AllReady: (pageCallback: (page: any, params: import("@cscec/udp-core").IPageCallbackParams, util: {
        execServer(funcName: string, paramObj: IObject, successCallback?: Function | undefined): Promise<import("@cscec/udp-core").IResponse | undefined>;
        external: any;
        request: import("@cscec/udp-core").CreateRequest;
        batchedUpdates: (callback: () => any) => void;
        getObserver(): import("@cscec/udp-core").Observer;
        getPageObserver(): import("@cscec/udp-core").Observer;
        createElement(type: string, props?: IObject | undefined, ...children: React.ReactNode[]): React.DOMElement<IObject, Element>;
        isReactElement: (obj: any) => boolean;
        isRunMaster: boolean;
        getPageInstance(): any;
        getPageLoadState: () => any;
        getCompMap(): any;
        getPageLang(): any;
        getPageUI(): any;
        getPageState(): any;
        getCmp(id: string): import("@cscec/udp-core").ICurrentObject<any>;
        getCmpByType(type: string): import("@cscec/udp-core").ICurrentObject<any>;
        getCmpApi(id: string): any;
        getComponentRef(id: string): any;
        getForms(): any;
        getGrids(): any;
        compIns: any;
        query(type: string): any;
        alert(content: React.ReactNode, type?: "default" | "single" | "multiple", others?: IObject): Promise<unknown>;
        confirm(content: React.ReactNode, others?: IObject): Promise<boolean>;
        showLoading(visible?: string | boolean): void;
        message(content: string, type?: string): any;
        openBlankUrl(url: any): void;
        getUser<T_1 = IObject>(): T_1;
        setUser(user?: IObject | undefined): void;
        getRoot(): string;
        getHttpUrl(url: string, root?: any): string;
        toFirstUpperCase(str: string): string;
        extend: (...args: any[]) => any;
        assign: (objA: any, objB: any) => false | Record<string, any>;
        clearObject: (obj: any) => void;
        numberPrecision(value: any, precision?: number): number;
        thousandNumber(value: any, options?: {
            separator?: string | undefined;
            includeDecimal?: boolean | undefined;
            precision?: number | undefined;
        }): any;
        uniqueId(key?: string, n?: number): string;
        deepCopyEx: (obj: any) => any;
        copyText(text: any): void;
        deepMerge(objA: object, objB: object, except?: string[]): object;
        getAggregate: (type: any, dataArr: any[], key?: string) => number | "*****" | "-";
        flatArray: (arr: any[], depth?: number) => any;
        filterTree: (nodes: IObject[], predicate: (node: any) => boolean, options?: {
            childrenKey?: string | undefined;
            leafKey?: string | undefined;
            includeChildren?: boolean | undefined;
        } | undefined) => any;
        groupBy: (dataArr: any[], f: (arg0: any) => any) => any;
        isPropsEqual(props: any, nextProps: any, config?: {
            shallow?: boolean | undefined;
            exclude?: string[] | undefined;
        }): boolean;
        isArrayEqual(arr1: any[], arr2: any[]): boolean;
        firstCase(str: any): any;
        getValueByPath: (obj: any, path: string) => any;
        getBirthDay({ idCard, format }: {
            idCard: any;
            format?: string | undefined;
        }): any;
        getAge({ idCard, birth, format }: {
            idCard?: string | undefined;
            birth?: string | undefined;
            format?: string | undefined;
        }): any;
        strToDate(dateStr: any): Date;
        formatDate(dateStr: any, format?: string): any;
        addDate(date: any, count: number, type?: "year" | "month" | "date" | "hours" | "minutes" | "seconds" | "milliseconds", format?: string | undefined): string | Date;
        regExpTest: (regExp: string | Function, value: any) => any;
        convertData: (data: any, dataType: import("@cscec/udp-core").ValueTypeEnum, format?: string) => any;
        getScrollBarInfo(container?: HTMLElement, cache?: boolean): any;
        getQueryValue(queryName?: string, options?: string | {
            search?: string | undefined;
            ignoreCase?: boolean | undefined;
            decode?: boolean | undefined;
            cache?: boolean | undefined;
        } | undefined): any;
        getCookie(name: any, dv?: any): any;
        handleData: (data: any) => any;
        handleUrl: (url: string, params?: IObject | undefined, isHttp?: boolean) => string;
        debounce: (func: any, wait: number, immediate?: boolean | undefined) => (...payload: any[]) => any;
        throttle: (func: any, wait: number, options?: {
            leading?: boolean | undefined;
            trailing?: boolean | undefined;
        } | undefined) => (...payload: any[]) => any;
        closest(el: any, fn: (el: any) => boolean): any;
        getStyle(dom: any, attr: any): any;
        delay: (timestamp: number) => Promise<unknown>;
        getCursorPosition(element?: any): any;
        getSelectionEnd(): any;
        setCursorPosition(ctrl: any, pos: any): void;
        classNames(...cls: (string | IObject<boolean> | undefined)[]): string;
        CryptoJS: {
            encode(word: any, opt?: Partial<{
                keyStr: string;
                mode: any;
                encodePadding: any;
                decodePadding: any;
            }>): any;
            decode(word: any, opt?: Partial<{
                keyStr: string;
                mode: any;
                encodePadding: any;
                decodePadding: any;
            }>): any;
            getCryptoJS(): any;
        };
        sm4: {
            encode(word: any, key?: string): any;
            decode(encodeWord: any, key?: string): any;
            getSm(): any;
        };
        Base64: {
            encode(data: any, useCryptoJS?: boolean): any;
            decode(encodedData: string, useCryptoJS?: boolean | "Utf8" | "Utf16" | "Utf16BE" | "Utf16LE"): any;
        };
        setCache(key: string, value: any, option?: {
            type: "local" | "session";
        } | undefined): void;
        getCache<T_2 = any>(key: string, option?: boolean | {
            type?: "local" | "session" | undefined;
            toObject?: boolean | undefined;
        }): T_2;
        removeCache(key: string, option?: {
            type: "local" | "session";
        } | undefined): void;
        downLoad({ url, filename, blob }: {
            url?: string | undefined;
            filename?: string | undefined;
            blob?: Blob | undefined;
        }): void;
        getAbsoluteUrl(url: any): string;
        debug(param: string | {
            msg: any;
            type?: "log" | "warn" | "error" | undefined;
        }): void;
        loopChildren(data: {
            children: IObject[];
        }, todo: (row: IObject, i: number, level: number, count: number) => boolean | void, level?: number, count?: number): false | undefined;
        getObjValue(obj: any, pathKeys: any, emptyValue?: any): any;
        setObjValue(obj: any, pathKeys: any, value: any): void;
        deleteObjKey(obj: any, pathKeys: any): void;
        split(str: any, _split?: string): string[];
        strLen(str: string, chnlen?: number | undefined): number;
        addAnimationend(el: any, callback: any): () => void;
        stopPropagation(e: any): void;
        isPromise(obj: any): obj is Promise<any>;
        isArray(arr: any): arr is any[];
        isFunction(fn: any): fn is Function;
        isObject(obj: any): obj is Record<string, any>;
        isNumber(v: any): v is number;
        isString(str: any): str is string;
        isBoolean(obj: any): boolean;
        isDate(date: any): date is Date;
        isNullOrEmpty(val: any, except?: "" | null | undefined): boolean;
        isSymbol(value: any): value is Symbol;
        deepCopy(obj: any, structuredClone?: boolean): any;
        jsonString: (json: any, undefinedValue?: any) => any;
        parseJson: (jsonStr: any) => any;
    }) => void, listPageCallback?: ((page: any, params: import("@cscec/udp-core").IPageCallbackParams, util: {
        execServer(funcName: string, paramObj: IObject, successCallback?: Function | undefined): Promise<import("@cscec/udp-core").IResponse | undefined>;
        external: any;
        request: import("@cscec/udp-core").CreateRequest;
        batchedUpdates: (callback: () => any) => void;
        getObserver(): import("@cscec/udp-core").Observer;
        getPageObserver(): import("@cscec/udp-core").Observer;
        createElement(type: string, props?: IObject | undefined, ...children: React.ReactNode[]): React.DOMElement<IObject, Element>;
        isReactElement: (obj: any) => boolean;
        isRunMaster: boolean;
        getPageInstance(): any;
        getPageLoadState: () => any;
        getCompMap(): any;
        getPageLang(): any;
        getPageUI(): any;
        getPageState(): any;
        getCmp(id: string): import("@cscec/udp-core").ICurrentObject<any>;
        getCmpByType(type: string): import("@cscec/udp-core").ICurrentObject<any>;
        getCmpApi(id: string): any;
        getComponentRef(id: string): any;
        getForms(): any;
        getGrids(): any;
        compIns: any;
        query(type: string): any;
        alert(content: React.ReactNode, type?: "default" | "single" | "multiple", others?: IObject): Promise<unknown>;
        confirm(content: React.ReactNode, others?: IObject): Promise<boolean>;
        showLoading(visible?: string | boolean): void;
        message(content: string, type?: string): any;
        openBlankUrl(url: any): void;
        getUser<T_1 = IObject>(): T_1;
        setUser(user?: IObject | undefined): void;
        getRoot(): string;
        getHttpUrl(url: string, root?: any): string;
        toFirstUpperCase(str: string): string;
        extend: (...args: any[]) => any;
        assign: (objA: any, objB: any) => false | Record<string, any>;
        clearObject: (obj: any) => void;
        numberPrecision(value: any, precision?: number): number;
        thousandNumber(value: any, options?: {
            separator?: string | undefined;
            includeDecimal?: boolean | undefined;
            precision?: number | undefined;
        }): any;
        uniqueId(key?: string, n?: number): string;
        deepCopyEx: (obj: any) => any;
        copyText(text: any): void;
        deepMerge(objA: object, objB: object, except?: string[]): object;
        getAggregate: (type: any, dataArr: any[], key?: string) => number | "*****" | "-";
        flatArray: (arr: any[], depth?: number) => any;
        filterTree: (nodes: IObject[], predicate: (node: any) => boolean, options?: {
            childrenKey?: string | undefined;
            leafKey?: string | undefined;
            includeChildren?: boolean | undefined;
        } | undefined) => any;
        groupBy: (dataArr: any[], f: (arg0: any) => any) => any;
        isPropsEqual(props: any, nextProps: any, config?: {
            shallow?: boolean | undefined;
            exclude?: string[] | undefined;
        }): boolean;
        isArrayEqual(arr1: any[], arr2: any[]): boolean;
        firstCase(str: any): any;
        getValueByPath: (obj: any, path: string) => any;
        getBirthDay({ idCard, format }: {
            idCard: any;
            format?: string | undefined;
        }): any;
        getAge({ idCard, birth, format }: {
            idCard?: string | undefined;
            birth?: string | undefined;
            format?: string | undefined;
        }): any;
        strToDate(dateStr: any): Date;
        formatDate(dateStr: any, format?: string): any;
        addDate(date: any, count: number, type?: "year" | "month" | "date" | "hours" | "minutes" | "seconds" | "milliseconds", format?: string | undefined): string | Date;
        regExpTest: (regExp: string | Function, value: any) => any;
        convertData: (data: any, dataType: import("@cscec/udp-core").ValueTypeEnum, format?: string) => any;
        getScrollBarInfo(container?: HTMLElement, cache?: boolean): any;
        getQueryValue(queryName?: string, options?: string | {
            search?: string | undefined;
            ignoreCase?: boolean | undefined;
            decode?: boolean | undefined;
            cache?: boolean | undefined;
        } | undefined): any;
        getCookie(name: any, dv?: any): any;
        handleData: (data: any) => any;
        handleUrl: (url: string, params?: IObject | undefined, isHttp?: boolean) => string;
        debounce: (func: any, wait: number, immediate?: boolean | undefined) => (...payload: any[]) => any;
        throttle: (func: any, wait: number, options?: {
            leading?: boolean | undefined;
            trailing?: boolean | undefined;
        } | undefined) => (...payload: any[]) => any;
        closest(el: any, fn: (el: any) => boolean): any;
        getStyle(dom: any, attr: any): any;
        delay: (timestamp: number) => Promise<unknown>;
        getCursorPosition(element?: any): any;
        getSelectionEnd(): any;
        setCursorPosition(ctrl: any, pos: any): void;
        classNames(...cls: (string | IObject<boolean> | undefined)[]): string;
        CryptoJS: {
            encode(word: any, opt?: Partial<{
                keyStr: string;
                mode: any;
                encodePadding: any;
                decodePadding: any;
            }>): any;
            decode(word: any, opt?: Partial<{
                keyStr: string;
                mode: any;
                encodePadding: any;
                decodePadding: any;
            }>): any;
            getCryptoJS(): any;
        };
        sm4: {
            encode(word: any, key?: string): any;
            decode(encodeWord: any, key?: string): any;
            getSm(): any;
        };
        Base64: {
            encode(data: any, useCryptoJS?: boolean): any;
            decode(encodedData: string, useCryptoJS?: boolean | "Utf8" | "Utf16" | "Utf16BE" | "Utf16LE"): any;
        };
        setCache(key: string, value: any, option?: {
            type: "local" | "session";
        } | undefined): void;
        getCache<T_2 = any>(key: string, option?: boolean | {
            type?: "local" | "session" | undefined;
            toObject?: boolean | undefined;
        }): T_2;
        removeCache(key: string, option?: {
            type: "local" | "session";
        } | undefined): void;
        downLoad({ url, filename, blob }: {
            url?: string | undefined;
            filename?: string | undefined;
            blob?: Blob | undefined;
        }): void;
        getAbsoluteUrl(url: any): string;
        debug(param: string | {
            msg: any;
            type?: "log" | "warn" | "error" | undefined;
        }): void;
        loopChildren(data: {
            children: IObject[];
        }, todo: (row: IObject, i: number, level: number, count: number) => boolean | void, level?: number, count?: number): false | undefined;
        getObjValue(obj: any, pathKeys: any, emptyValue?: any): any;
        setObjValue(obj: any, pathKeys: any, value: any): void;
        deleteObjKey(obj: any, pathKeys: any): void;
        split(str: any, _split?: string): string[];
        strLen(str: string, chnlen?: number | undefined): number;
        addAnimationend(el: any, callback: any): () => void;
        stopPropagation(e: any): void;
        isPromise(obj: any): obj is Promise<any>;
        isArray(arr: any): arr is any[];
        isFunction(fn: any): fn is Function;
        isObject(obj: any): obj is Record<string, any>;
        isNumber(v: any): v is number;
        isString(str: any): str is string;
        isBoolean(obj: any): boolean;
        isDate(date: any): date is Date;
        isNullOrEmpty(val: any, except?: "" | null | undefined): boolean;
        isSymbol(value: any): value is Symbol;
        deepCopy(obj: any, structuredClone?: boolean): any;
        jsonString: (json: any, undefinedValue?: any) => any;
        parseJson: (jsonStr: any) => any;
    }) => void) | null | undefined, options?: {
        delay?: boolean | undefined;
        from?: string | undefined;
        priorityTop?: boolean | undefined;
    } | undefined) => void;
    PageReady: typeof import("@cscec/udp-core").PageReady;
    updateUI: (uiInfo: Function | IObject<number>[], config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
    updateState: (payload: Function | IObject, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
    fastDp: {
        statusKey: symbol;
        itemsKey: symbol;
        updateDevUI: (devUi: {
            toolbar?: (Function | IObject) | undefined;
            form?: (Function | IObject) | undefined;
            table?: (Function | IObject) | undefined;
            query?: (Function | IObject) | undefined;
        }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
        toolbar: {
            updateProps: ({ id, props }: {
                id: string;
                props: IObject;
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            addItems: ({ id, items, insertIndex }: {
                id: string;
                items: ({
                    id: string;
                } & {
                    [k: string]: any;
                })[];
                insertIndex?: number | undefined;
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            updateItems: ({ id, items }: {
                id: string;
                items: ({
                    id: string;
                } & {
                    [k: string]: any;
                })[];
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            deleteItems: ({ id, items }: {
                id: string;
                items: string[];
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            setItems: ({ id, items }: {
                id: string;
                items: import("@cscec/udp-core").TypeOrFn<any[], any[]>;
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
        };
        form: {
            updateProps: ({ id, props }: {
                id: string;
                props: IObject;
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            addItems: ({ id, items, insertIndex }: {
                id: string;
                items: ({
                    name: string;
                } & {
                    [k: string]: any;
                })[];
                insertIndex?: number | undefined;
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            updateItems: ({ id, items }: {
                id: string;
                items: ({
                    name: string;
                } & {
                    [k: string]: any;
                })[];
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            deleteItems: ({ id, items }: {
                id: string;
                items: string[];
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            setItems: ({ id, items }: {
                id: string;
                items: import("@cscec/udp-core").TypeOrFn<any[], any[]>;
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
        };
        table: {
            updateProps: ({ id, props }: {
                id: string;
                props: IObject;
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            addItems: ({ id, items, insertIndex }: {
                id: string;
                items: ({
                    dataIndex: string;
                } & {
                    [k: string]: any;
                })[];
                insertIndex?: number | undefined;
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            updateItems: ({ id, items }: {
                id: string;
                items: ({
                    dataIndex: string;
                } & {
                    [k: string]: any;
                })[];
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            deleteItems: ({ id, items }: {
                id: string;
                items: string[];
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            setItems: ({ id, items }: {
                id: string;
                items: import("@cscec/udp-core").TypeOrFn<any[], any[]>;
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
        };
        query: {
            updateProps: ({ id, props }: {
                id: string;
                props: IObject;
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
            updateItems: ({ id, items }: {
                id: string;
                items: (IObject & {
                    [k: string]: any;
                })[];
            }, config?: import("@cscec/udp-core").IUpdateConfig | undefined) => void;
        };
    };
    getDispatch(): any;
    execServer(funcName: string, paramObj: IObject, successCallback?: Function | undefined): Promise<import("@cscec/udp-core").IResponse | undefined>;
    external: any;
    request: import("@cscec/udp-core").CreateRequest;
    batchedUpdates: (callback: () => any) => void;
    getObserver(): import("@cscec/udp-core").Observer;
    getPageObserver(): import("@cscec/udp-core").Observer;
    createElement(type: string, props?: IObject | undefined, ...children: React.ReactNode[]): React.DOMElement<IObject, Element>;
    isReactElement: (obj: any) => boolean;
    isRunMaster: boolean;
    getPageInstance(): any;
    getPageLoadState: () => any;
    getCompMap(): any;
    getPageLang(): any;
    getPageUI(): any;
    getPageState(): any;
    getCmp(id: string): import("@cscec/udp-core").ICurrentObject<any>;
    getCmpByType(type: string): import("@cscec/udp-core").ICurrentObject<any>;
    getCmpApi(id: string): any;
    getComponentRef(id: string): any;
    getForms(): any;
    getGrids(): any;
    compIns: any;
    query(type: string): any;
    alert(content: React.ReactNode, type?: "default" | "single" | "multiple", others?: IObject): Promise<unknown>;
    confirm(content: React.ReactNode, others?: IObject): Promise<boolean>;
    showLoading(visible?: string | boolean): void;
    message(content: string, type?: string): any;
    openBlankUrl(url: any): void;
    setUser(user?: IObject | undefined): void;
    getRoot(): string;
    getHttpUrl(url: string, root?: any): string;
    toFirstUpperCase(str: string): string;
    extend: (...args: any[]) => any;
    assign: (objA: any, objB: any) => false | Record<string, any>;
    clearObject: (obj: any) => void;
    numberPrecision(value: any, precision?: number): number;
    thousandNumber(value: any, options?: {
        separator?: string | undefined;
        includeDecimal?: boolean | undefined;
        precision?: number | undefined;
    }): any;
    uniqueId(key?: string, n?: number): string;
    deepCopyEx: (obj: any) => any;
    copyText(text: any): void;
    deepMerge(objA: object, objB: object, except?: string[]): object;
    getAggregate: (type: any, dataArr: any[], key?: string) => number | "*****" | "-";
    flatArray: (arr: any[], depth?: number) => any;
    filterTree: (nodes: IObject[], predicate: (node: any) => boolean, options?: {
        childrenKey?: string | undefined;
        leafKey?: string | undefined;
        includeChildren?: boolean | undefined;
    } | undefined) => any;
    groupBy: (dataArr: any[], f: (arg0: any) => any) => any;
    isPropsEqual(props: any, nextProps: any, config?: {
        shallow?: boolean | undefined;
        exclude?: string[] | undefined;
    }): boolean;
    isArrayEqual(arr1: any[], arr2: any[]): boolean;
    firstCase(str: any): any;
    getValueByPath: (obj: any, path: string) => any;
    getBirthDay({ idCard, format }: {
        idCard: any;
        format?: string | undefined;
    }): any;
    getAge({ idCard, birth, format }: {
        idCard?: string | undefined;
        birth?: string | undefined;
        format?: string | undefined;
    }): any;
    strToDate(dateStr: any): Date;
    formatDate(dateStr: any, format?: string): any;
    addDate(date: any, count: number, type?: "year" | "month" | "date" | "hours" | "minutes" | "seconds" | "milliseconds", format?: string | undefined): string | Date;
    regExpTest: (regExp: string | Function, value: any) => any;
    convertData: (data: any, dataType: import("@cscec/udp-core").ValueTypeEnum, format?: string) => any;
    getScrollBarInfo(container?: HTMLElement, cache?: boolean): any;
    getQueryValue(queryName?: string, options?: string | {
        search?: string | undefined;
        ignoreCase?: boolean | undefined;
        decode?: boolean | undefined;
        cache?: boolean | undefined;
    } | undefined): any;
    getCookie(name: any, dv?: any): any;
    handleData: (data: any) => any;
    handleUrl: (url: string, params?: IObject | undefined, isHttp?: boolean) => string;
    debounce: (func: any, wait: number, immediate?: boolean | undefined) => (...payload: any[]) => any;
    throttle: (func: any, wait: number, options?: {
        leading?: boolean | undefined;
        trailing?: boolean | undefined;
    } | undefined) => (...payload: any[]) => any;
    closest(el: any, fn: (el: any) => boolean): any;
    getStyle(dom: any, attr: any): any;
    delay: (timestamp: number) => Promise<unknown>;
    getCursorPosition(element?: any): any;
    getSelectionEnd(): any;
    setCursorPosition(ctrl: any, pos: any): void;
    classNames(...cls: (string | IObject<boolean> | undefined)[]): string;
    CryptoJS: {
        encode(word: any, opt?: Partial<{
            keyStr: string;
            mode: any;
            encodePadding: any;
            decodePadding: any;
        }>): any;
        decode(word: any, opt?: Partial<{
            keyStr: string;
            mode: any;
            encodePadding: any;
            decodePadding: any;
        }>): any;
        getCryptoJS(): any;
    };
    sm4: {
        encode(word: any, key?: string): any;
        decode(encodeWord: any, key?: string): any;
        getSm(): any;
    };
    Base64: {
        encode(data: any, useCryptoJS?: boolean): any;
        decode(encodedData: string, useCryptoJS?: boolean | "Utf8" | "Utf16" | "Utf16BE" | "Utf16LE"): any;
    };
    setCache(key: string, value: any, option?: {
        type: "local" | "session";
    } | undefined): void;
    getCache<T_2 = any>(key: string, option?: boolean | {
        type?: "local" | "session" | undefined;
        toObject?: boolean | undefined;
    }): T_2;
    removeCache(key: string, option?: {
        type: "local" | "session";
    } | undefined): void;
    downLoad({ url, filename, blob }: {
        url?: string | undefined;
        filename?: string | undefined;
        blob?: Blob | undefined;
    }): void;
    getAbsoluteUrl(url: any): string;
    debug(param: string | {
        msg: any;
        type?: "log" | "warn" | "error" | undefined;
    }): void;
    loopChildren(data: {
        children: IObject[];
    }, todo: (row: IObject, i: number, level: number, count: number) => boolean | void, level?: number, count?: number): false | undefined;
    getObjValue(obj: any, pathKeys: any, emptyValue?: any): any;
    setObjValue(obj: any, pathKeys: any, value: any): void;
    deleteObjKey(obj: any, pathKeys: any): void;
    split(str: any, _split?: string): string[];
    strLen(str: string, chnlen?: number | undefined): number;
    addAnimationend(el: any, callback: any): () => void;
    stopPropagation(e: any): void;
    isPromise(obj: any): obj is Promise<any>;
    isArray(arr: any): arr is any[];
    isFunction(fn: any): fn is Function;
    isObject(obj: any): obj is Record<string, any>;
    isNumber(v: any): v is number;
    isString(str: any): str is string;
    isBoolean(obj: any): boolean;
    isDate(date: any): date is Date;
    isNullOrEmpty(val: any, except?: "" | null | undefined): boolean;
    isSymbol(value: any): value is Symbol;
    deepCopy(obj: any, structuredClone?: boolean): any;
    jsonString: (json: any, undefinedValue?: any) => any;
    parseJson: (jsonStr: any) => any;
};
export declare function registerComponent(Components: Record<string, React.ComponentType<any>>, options?: IRegisterComponentOptions): void;
export declare function getRegisterComponent<T = any>(type?: string, candidate?: string): T;
export declare function getRegisterComponentWithProps<T = any>(type?: string, candidate?: string): [T, IObject, IObject];
/**
 * 回刷列表hook
 * @param effect 回刷列表的副作用函数
 * @param busType 业务类型
 */
export declare function useRefreshList(effect: (data: any) => void, busType: string): void;
export declare function getGlobalContainer(): any;
export declare function getFileCenterApiUrl(relativeUrl: string): {
    absUrl: boolean;
    url: string;
};
export declare function getUdpFilePreviewUrl(fileId: string): {
    url: string;
    absUrl: boolean;
};
