var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/util/index.ts
var util_exports = {};
__export(util_exports, {
  getFileCenterApiUrl: () => getFileCenterApiUrl,
  getGlobalContainer: () => getGlobalContainer,
  getRegisterComponent: () => getRegisterComponent,
  getRegisterComponentWithProps: () => getRegisterComponentWithProps,
  getUdpFilePreviewUrl: () => getUdpFilePreviewUrl,
  registerComponent: () => registerComponent,
  udp: () => udp,
  useRefreshList: () => useRefreshList
});
module.exports = __toCommonJS(util_exports);
var import_udp_core = require("@cscec/udp-core");
var import_react = require("react");
var import_common = require("./common");
__reExport(util_exports, require("@cscec/udp-core"), module.exports);
var udp = {
  ...import_udp_core.core,
  ...import_common.CommonUtil,
  registerExternal(obj) {
    import_udp_core.core.registerExternal(obj, false);
  }
};
function registerComponent(Components, options) {
  (0, import_udp_core.registerCpts)(Components, { ...options, platform: "pc" });
}
function getRegisterComponent(type = "", candidate = "") {
  return (0, import_udp_core.getRegisterCpt)(type, "pc", candidate);
}
function getRegisterComponentWithProps(type = "", candidate = "") {
  return (0, import_udp_core.getRegisterCptWithProps)(type, "pc", candidate);
}
function useRefreshList(effect, busType) {
  (0, import_react.useEffect)(() => {
    return import_common.CommonUtil.onRefreshList(busType, effect);
  }, []);
}
function getGlobalContainer() {
  var _a, _b;
  const name = (_b = (_a = udp.external).getQianKun) == null ? void 0 : _b.call(_a).name;
  return name ? document.body.querySelector(`div[data-qiankun="${name}"]`) || document.body : document.body;
}
function getFileCenterApiUrl(relativeUrl) {
  const { fileUrl } = udp.getUser();
  return {
    absUrl: fileUrl ? true : false,
    url: fileUrl ? `${fileUrl}${relativeUrl}` : relativeUrl
  };
}
var isDev = process.env.NODE_ENV === "development";
function getUdpFilePreviewUrl(fileId) {
  const { accessToken } = udp.getUser();
  const { url, absUrl } = getFileCenterApiUrl(`/udp-file/doc/file/preview?fileId=${fileId}&User-Token=${accessToken}`);
  const nextUrl = absUrl ? url : `${isDev ? "/proxy" : location.origin}${url}`;
  return {
    url: nextUrl,
    absUrl
  };
}
(0, import_udp_core.setGlobalVar)("$udp", udp);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getFileCenterApiUrl,
  getGlobalContainer,
  getRegisterComponent,
  getRegisterComponentWithProps,
  getUdpFilePreviewUrl,
  registerComponent,
  udp,
  useRefreshList,
  ...require("@cscec/udp-core")
});
